MODULE NewSort;

FROM ELib IMPORT FileBufPtr,Buf32Ptr,ChangeExtension,AddLAddr;
FROM Str IMPORT CHARSET,Copy,Length;
FROM Storage IMPORT ALLOCATE,DEALLOCATE,Available;
FROM CoreCrt IMPORT GotoXY,WhereX,WhereY;
FROM StopWatch IMPORT LookStopWatch,StartStopWatch;
FROM Lib IMPORT QSort,CompareProc,HSort,Fill,Terminate;

IMPORT FIO,IO,Storage,CoreEFIO,XMS;

CONST StringLength=122;
      StrArr=511;

TYPE TheType= RECORD
               FPos   : LONGCARD;
               FSiz   : CARDINAL;
               String : ARRAY[0..StringLength-1] OF CHAR;
               END;
     ThePtr = POINTER TO TheType;
     TheArray= ARRAY[0..StrArr-1] OF TheType;
     TheArrayPtr= POINTER TO TheArray;

VAR FIn         : FIO.File;
    Root        : TheArrayPtr;
    ThisPnt     : CARDINAL;
    ThisBuf     : Buf32Ptr;
    RecInMem    : CARDINAL;
    TotalRec    : LONGCARD;
    TwirCount,
    TwirNr,
    TwirMask    : CARDINAL;
    XMSMapped   : BOOLEAN;
    Handle      : CARDINAL;
    EndProc     : PROC;
    InBlock     : ARRAY[0..9] OF CARDINAL;
    BlockPtr    : ARRAY[0..9] OF CARDINAL;
    


PROCEDURE KillXMS;

BEGIN
IF XMSMapped THEN
 XMS.EMBFreeMem(Handle);       (* Free XMS*)
 XMSMapped:=FALSE;
 END;
END KillXMS;

PROCEDURE ToXMS(Pos64k,XMSPos320k,XMSPos64k:CARDINAL);

(* Move 64k block starting on Root+Pos64K*65536 to the XMS handle on
position XMSPos320K*320K+XMSPos64k*64K *)

VAR Ptr : ThePtr;

BEGIN
 INC(XMSPos64k,XMSPos320k*6);
 Ptr:=AddLAddr(Root,Pos64k<<12);
 XMS.MoveToEMB(Ptr,Handle,65536,LONGCARD(XMSPos64k)<<16);
END ToXMS;

PROCEDURE FromXMS(Pos64k,XMSPos320k,XMSPos64k:CARDINAL);

(* ToXMS the otherway around *)

VAR Ptr : ThePtr;

BEGIN
 INC(XMSPos64k,XMSPos320k*6);
 Ptr:=AddLAddr(Root,Pos64k<<12);
 XMS.MoveFromEMB(Ptr,Handle,65536,LONGCARD(XMSPos64k)<<16);
END FromXMS;

PROCEDURE ToBlock(TargetBlock,Recs : CARDINAL);

VAR A :CARDINAL;

BEGIN
 FOR A:=0 TO 5 DO
  ToXMS(A,TargetBlock,A);
  END;
 InBlock[TargetBlock]:=Recs;
END ToBlock;

CONST TwirlStr="\/";

PROCEDURE Twirly;

BEGIN
 INC (TwirCount);
 IF (TwirCount AND TwirMask)=0 THEN
  INC(TwirNr);
  GotoXY(WhereX()-1,WhereY());
  IO.WrChar(TwirlStr[TwirNr AND 3]);
  END;
END Twirly;

PROCEDURE KillTwir;

BEGIN
 GotoXY(WhereX()-1,WhereY());
 IO.WrChar(" ");
END KillTwir;

PROCEDURE EndStopWatch;

VAR Time : LONGCARD;
    A,C : CARDINAL;

BEGIN
 IO.WrStr("Sorting ");
 IO.WrCard(RecInMem,0); IO.WrStr(" jokes took ");
 Time:=LookStopWatch(C);
 IF Time>60 THEN
  A:=CARDINAL(Time DIV 60);
  IO.WrCard(A,0); IO.WrStr(" minutes, ");
  Time:=Time MOD 60;
  END;
 IO.WrLngCard(Time,0); IO.WrChar(".");
 IF C<10 THEN
  IO.WrChar("0");
  END;
 IO.WrCard(C,0); IO.WrStr(" seconds"); IO.WrLn;
END EndStopWatch;

VAR CurPos : LONGCARD;
    Fl     : BOOLEAN;
(*
PROCEDURE CmpName(A,B : CARDINAL):BOOLEAN;
BEGIN
 Twirly;
 Fl:=(Big^[A-1]^.String[0]=CHR("#"));
 IF Big^[B-1]^[0]=CHR("#") THEN
  IF Fl THEN
   IF Big^[A-1]^[1]#" " THEN
    RETURN TRUE;
   ELSE
    RETURN FALSE;
    END;
  ELSE
   RETURN FALSE;
   END;
  END;
 IF Fl THEN
  RETURN TRUE;
  END;
 RETURN (Compare(Big^[A-1]^,Big^[B-1]^)<0)
END CmpName;

PROCEDURE CmpSize(A,B : CARDINAL):BOOLEAN;
BEGIN
 Twirly;
 IF Big^[A-1]^[0]=CHR("#") THEN
  RETURN TRUE;
 ELSE
  RETURN FSize^[A-1]<FSize^[B-1]
  END;
END CmpSize;

PROCEDURE Swp(A,B:CARDINAL);

VAR S : ARRAY[0..90] OF CHAR;
    FP :LONGCARD;
    Si : CARDINAL;

BEGIN
 Si:=FSize^[A-1];    FSize^[A-1]:=FSize^[B-1];     FSize^[B-1]:=Si;
 FP:=FPos^[A-1];     FPos^[A-1]:=FPos^[B-1];       FPos^[B-1]:=FP;
 Copy(S,Big^[A-1]^); Copy(Big^[A-1]^,Big^[B-1]^);  Copy (Big^[B-1]^,S);
END Swp;
*)

PROCEDURE ReadRecord(FIn:FIO.File);

VAR C : CHAR;

BEGIN
 C:=FIO.RdChar(FIn);
 ThisBuf^[0]:=CHR(C);
 ThisPnt:=1;
 LOOP
  C:=FIO.RdChar(FIn);
  IF C=CHR(1) THEN
   C:=CHR(32);
   END;
  IF FIO.EOF THEN
   RETURN;
   END;
  IF C="<" THEN
   ThisBuf^[ThisPnt]:="<";
   C:=FIO.RdChar(FIn);
   ThisBuf^[ThisPnt+1]:=C;
   IF C="$" THEN
    C:=FIO.RdChar(FIn);
     ThisBuf^[ThisPnt+2]:=C;
     IF C=">" THEN
      EXIT
     ELSE
      INC(ThisPnt,3);
      END;
     ELSE
      INC(ThisPnt,2);
      END;
   ELSE
    ThisBuf^[ThisPnt]:=C;
    INC(ThisPnt);
    END;
  END;
END ReadRecord;

VAR FOut : FIO.File;

PROCEDURE Flush;

VAR A,B :CARDINAL;
    Big: ThePtr;

BEGIN
 IF RecInMem # 0 THEN
 FOR A:=0 TO RecInMem-1 DO
  Big:=AddLAddr(Root,A*8); (* 128/16=8 *)
  B:=6+Length(Big^.String);
  CoreEFIO.Wr16(FOut,B);
  FIO.WrBin(FOut,Big^,B);
  END;
 END;
 INC(TotalRec,LONGCARD(RecInMem));
 RecInMem:=0;
END Flush;

PROCEDURE CheckBuffer;

CONST KillSet=CHARSET{CHR(13),CHR(10),'"',"'"," ","`","[","("};

VAR A,B : CARDINAL;
    Big : ThePtr;

BEGIN

 IF ThisPnt #0 THEN
  IF RecInMem>(StrArr-2) THEN
   Flush;
   END;
  Big:=AddLAddr(Root,RecInMem*8);
  Fill(ADR(Big^),128,0);
  Big^.FSiz:=ThisPnt;
  Big^.FPos:=CurPos;
  A:=0;
  IF ThisBuf^[A]=BYTE("!") THEN
   WHILE ThisBuf^[A]#BYTE(10) DO
    INC(A);
    END;
   INC(A);
   END;
  WHILE CHAR(ThisBuf^[A]) IN KillSet DO
   INC(A);
   END;
  B:=0;
  REPEAT
   Big^.String[B]:=CAP(CHR(ThisBuf^[A+B]));
   INC(B);
  UNTIL (ThisBuf^[A+B]=BYTE(13)) OR (B=StringLength);
  IF B # StringLength THEN
   Big^.String[B]:=CHR(0);
   END;
  INC(RecInMem);
  IF RecInMem=StrArr THEN
   Flush; FIO.Close(FOut);
   IO.WrStr("Algoritm error, please report to author"); IO.WrLn;HALT;
   END;
 END;
END CheckBuffer;

VAR B1,B2: FileBufPtr;

PROCEDURE CreateSystemp;

BEGIN
 FOut:=FIO.Create("tmp.tmp");
 FIO.AssignBuffer(FOut,B2);
 FIO.Seek(FIn,0);
 RecInMem  :=0;
 LOOP
  CurPos:=FIO.GetPos(FIn);
  ReadRecord(FIn);                      (* Read a Joke*)
  IF FIO.EOF THEN
   CheckBuffer;                          (* Append joke to buffer *)
   Flush;
   EXIT;                                 (* Exit LOOP *)
   END;
  Twirly;
  CheckBuffer;
  END;
 FIO.Close(FOut);
END CreateSystemp;

(*
PROCEDURE Dump;
VAR F3 : FIO.File;
    A:CARDINAL;
BEGIN
 F3:=FIO.Create("Dump.bak");
 FOR A:=0 TO NoRec-1 DO
  FIO.WrStr(F3,Big^[A]^); FIO.WrLn(F3);
  END;
 FIO.Close(F3);
END Dump;
*)

PROCEDURE SetupSys;

BEGIN
 NEW(ThisBuf); NEW(B1);NEW(B2);
 (* Allocate 320k; 320k=320*8=2048 strings. (k=1024b is this case) *)
 Storage.HeapAllocate(Storage.MainHeap,Root,320*64);
 RecInMem:=0;
END SetupSys;

PROCEDURE CookSrt(Name : ARRAY OF CHAR;SortSize :BOOLEAN;Dump1stLines:BOOLEAN);


PROCEDURE CleanUp;
VAR LU : CARDINAL;

BEGIN
  FIO.Close(FIn);
  Storage.HeapDeallocate(Storage.MainHeap,Root,320*64);

  DISPOSE(ThisBuf);
  DISPOSE(B1);DISPOSE(B2);
END CleanUp;

VAR Sort : CompareProc;
    A,B  : CARDINAL;
    T1,T2 : FIO.PathStr;

BEGIN
 XMSMapped:=FALSE; Fill(ADR(InBlock),12,0);
 Fill(ADR(BlockPtr),12,0);
 
 SetupSys; TotalRec:=0;
 StartStopWatch;
 FIn:=FIO.Open(Name);
 FIO.AssignBuffer(FIn,B1^);
 A:=CARDINAL(FIO.RdChar(FIn));
 IF A # CARDINAL("#") THEN
  IO.WrStr("No valid SRC file '"); IO.WrStr(Name);IO.WrLn;
  CleanUp;
  HALT;
  END;
 IO.WrStr("Reading file : "); IO.WrStr(Name); IO.WrStr("(Grabbing every 1st line of a joke)  ");
 TwirMask:=63;
 Twirly;
 CreateSystemp;
 KillTwir;
 IO.WrLngCard(TotalRec,10);
 IO.WrStr("Grabbing 3072k XMS"); IO.WrLn;
 Handle:=XMS.EMBGetMem(3072);  (* Allocate 3 MB XMS *)
 IF XMS.XMSError#BYTE(0) THEN
  IO.WrStr("- Allocation failed, couldn't get 3 MB XMS"); IO.WrLn;
  IO.WrStr("Command aborted");
  HALT;
  END;
 XMSMapped:=TRUE;
 Terminate(KillXMS,EndProc);

 HALT;

 (*
 IF SortSize THEN
  Sort:=CmpSize;
 ELSE
  Sort:=CmpName
  END; *)
 IO.WrLn;
 TwirMask:=2047;
 IO.WrStr("Sorting : "); IO.WrStr(Name); IO.WrStr("  ");
(*IF UseQSort THEN
  QSort(RecInMem,Sort,Swp);
 ELSE
  HSort(RecInMem,Sort,Swp);
  END; *)
 KillTwir;
 IO.WrLn;
 Copy(T1,Name);
 Copy(T2,Name);
 ChangeExtension(T2,"BAK");
 ChangeExtension(T1,"TMP");
 TwirMask:=127;
(*
 IO.WrStr("Writing file to disk  ");
 FOut:=FIO.Create(T1);
 FIO.AssignBuffer(FOut,B2^);
 FOR A := 0 TO RecInMem-1 DO
  FIO.Seek(FIn,FPos^[A]);
  Twirly;
  B:=FIO.RdBin(FIn,ThisBuf^[0],FSize^[A]);
  WHILE CHAR(ThisBuf^[FSize^[A]-1]) IN Kill DO
   DEC(FSize^[A]);
   END;
  FIO.WrBin(FOut,ThisBuf^,FSize^[A]);
  IF A#(RecInMem-1) THEN
   FIO.WrLn(FOut);
   FIO.WrStr(FOut,"<$>");
   END;
  END;
 KillTwir;
 FIO.Close(FOut);
 IO.WrLn;
 IF Dump1stLines THEN
  Dump;
  END;
 IO.WrStr("Renaming and cleaning up");
 CleanUp;
 IF FIO.Exists(T2) THEN
  FIO.Erase(T2);
  END;
 FIO.Rename(Name,T2);
 FIO.Rename(T1,Name);
 IO.WrLn;
 EndStopWatch; *)
END CookSrt;

BEGIN
 CookSrt ("eng_1.SRC",FALSE,FALSE);
END NewSort.