IMPLEMENTATION MODULE Crt;

FROM Lib IMPORT FarWordFill,FarWordMove;
FROM Str IMPORT Length,CHARSET;
FROM Storage IMPORT FarAllocate,FarDeallocate;

IMPORT IO;

CONST Screen          ::= CoreCrt.Screen;  (* Full address of the screen  *)
      NotCorrect        = MAX(CARDINAL);   (* Used as flag in ANSI handling*)

(* The following characters are redirected to DOS, CR, LF, Bell and NULL,
   NULL however is ignored *)

CONST Set=CHARSET{CHR(13),CHR(10),CHR(8),CHR(7),CHR(0)};

VAR
    OldProc  : IO.WrStrType;
    OldPrompt,
    CrtActive: BOOLEAN;
    AnsiX,AnsiY : CARDINAL;

(*PROCEDURE ScrollUp2(X1,Y1,X2,Y2,Lines :CARDINAL);

(* Bios Interrupt 10.06 (Int 10 AH=6 ) scrolls up X1,Y1 X2,Y2 and
   inserts "Lines" rows (color of new,inserted rows=random)
   The random color is the reason for the WordFill)
   this appears to be a defiency of some videocards, not all *)

VAR nx   : CARDINAL;

BEGIN
 ScrollUp(X1,Y1,X2,Y2,Lines); (* Doet de Bios scrollup *)

(* Clear inserted lines *)
  FarWordFill(FarADR(Screen^[(Y2-Lines+1)*ScrDat.Width]),ScrDat.Width*Lines,(CARDINAL(TColor) )<<8);
END ScrollUp2; *)

PROCEDURE WrapScreen;
(*This procedure normalises CurX and CurY to values within the screen bounderies,
  and scrolls the screen accordingly. *)

BEGIN
 IF CurX>0F000H THEN  CurX:=0;  END; (* Don't react on wrong values *)
 IF CurY>0F000H THEN  CurY:=0;  END;
 WHILE CurX> (ScrDat.Width-1) DO   (* Normalize x-coordinate(columns) *)
  DEC(CurX,ScrDat.Width);          (* X> screenwidth? then  *)
  INC(CurY);                       (* advance to next line *)
  END;
 IF CurY>ScrDat.Depth THEN
  ScrollUp3(CurY-ScrDat.Depth);
  CurY:=ScrDat.Depth;
  END;
 DoCursor;
END WrapScreen;

PROCEDURE WriteC (  C : CHAR);
(* The characters in 'Set' are rerouted to DOS (= IOWrStr routine)
    I use it to be able to continue bell and such special characters,
    IOWrStr is assembly equivalent normal IO.WrStr routine. *)
BEGIN
    CASE C OF
    (* Trap linefeed, because the own scrolling is better, see comment
       ScrollDown2 ! *)
    | CHR(10) : INC(CurY);
                WrapScreen;
    (* Just in case a wrong CHR(0) character gets through, specially when
       ANSI handling is on *)
    | CHR(0):
    | CHR(13): CurX:=0;
    ELSE

     IOWrStr(C);
     ToCursor
     END;
END WriteC;

PROCEDURE DoAttr(T:CARDINAL);
(* Subprocedure ANSI-handling, changes values in ansi escape sequences to real
    color codes (0..15) inclusive some special effects as blink
    Should be written in assembly for (marginal) speedincrease,
    but since ANSI-handling is still under development, I keep it in easier
    to maintain modula2*)

TYPE TabelType=ARRAY[0..7] OF BYTE;

CONST Tab=TabelType(0,4,2,6,1,5,3,7);

BEGIN
 IF T>37 THEN
  DEC(T,40);
  TColor:=BYTE((CARDINAL(TColor) AND 15) OR (CARDINAL(Tab[T])<<4));
 ELSIF T>10 THEN
  DEC(T,30);
  TColor:=BYTE((CARDINAL(TColor) AND 248) OR (CARDINAL(Tab[T])));
 ELSE
  CASE T OF (*  special effects*)
     | 8 : TColor:=0;
     | 0 : TColor:=7;
     | 1 : TColor:=TColor OR 8;
     | 5 : TColor:=TColor OR 128;
     END;
  END;
END DoAttr;

PROCEDURE StrWithCursor(S:ARRAY OF CHAR);

(* String to Screen with cursor upgrade, the main procedure. *)

VAR Tot : CARDINAL;
    Cor : CARDINAL;
    A,B,ScreenB : CARDINAL;
    Fl          : BOOLEAN;
    Ret         : CARDINAL;
    T           : ARRAY[0..5] OF CARDINAL;
    Tmp         : CARDINAL;
    YWidth      : CARDINAL;

BEGIN
 Tot:=Length(S);
 Cor:=0;
 B:=Length(S);
 YWidth:=CurY*ScrDat.Width;
 IF B>0 THEN
  ScreenB:=ScrDat.Width*(ScrDat.Depth+1)-1; (* Precalculate screensize in bytes*)
  A:=0;
  LOOP
   Fl:=FALSE;
   IF TrapAnsi THEN     (* Ansi Handling, not commented, too complex,
                           speeds down. Disable when not needed. *)
    IF S[A]=CHR(27) THEN
     INC(CurX,A-Cor);
     DoCursor;
     WrapScreen;
     FOR Ret:=0 TO 5 DO
      T[Ret]:=NotCorrect;
      END;
     IF (S[A+2]="2") AND (S[A+3]="J") THEN
      ClrScr;
      Ret:=4;
     ELSE
      Ret:=3;
      CASE S[A+2] OF
       | "K"      : GotoXY(1,CurY);
                    ClrEol;
       | "s"      : AnsiX:=CurX;
                    AnsiY:=CurY;
       | "u"      : GotoXY(AnsiX,AnsiY);
       | "A"      : DEC(CurY);
       | "B"      : INC(CurY);
       | "C"      : INC(CurX);
       | "D"      : IF CurX=0 THEN
                     IF CurY>1 THEN
                      DEC(CurY);
                      END;
                     CurX:=79;
                    ELSE
                     DEC(CurX);
                     END;
       | "H"      : CurX:=0; CurY:=0;
       | "0".."9",";" : IF S[A+2]=";" THEN
                         Ret:=A+2;
                         T[0]:=0;
                        ELSE
                         Ret:=CoreCrt.ReadNumber(S,T[0],A+2);
                         END;
                    FOR Tmp:=1 TO 5 DO
                     IF S[Ret]=";" THEN
                      Ret:=CoreCrt.ReadNumber(S,T[Tmp],Ret+1);
                      END;
                     END;
                    CASE S[Ret] OF
                     "H","f" : IF T[1] #NotCorrect THEN
                                GotoXY(T[1]-1,T[0]-1);
                               ELSE
                                GotoXY(0,T[0]-1);
                                END;
                   | "A"     : DEC(CurY,T[0]);
                   | "B"     : INC(CurY,T[0]);
                   | "C"     : INC(CurX,T[0]);
                   | "D"     : DEC(CurX,T[0] MOD ScrDat.Width);
                               DEC(CurY,T[0] DIV ScrDat.Width);
                               IF CurY>65000 THEN
                                CurY:=0;
                                END;
                   | "m"     : DoAttr(T[0]);
                               FOR Tmp:=1 TO 5 DO
                                IF T[Tmp] # NotCorrect THEN
                                 DoAttr(T[Tmp]);
                                 END;
                                END;
                       END;
                  DEC(Ret,A-1);

           END;
          END;
        WrapScreen;
        INC(A,Ret);
        Cor:=A;
        IF A=B THEN
         Cor:=B-1;
         END;
        YWidth:=CurY*ScrDat.Width;
        Fl:=TRUE;
     END;
    END;
   IF NOT Fl THEN
    IF (CurX+A-Cor+YWidth)=ScreenB THEN
     IF (S[A] # CHR(10)) AND (S[A] IN Set) THEN
      WriteC(S[A]);
     ELSE
      Screen^[ScreenB]:=ORD(S[A])+ CARDINAL(TColor)<<8;
      END;
     IF (NOT  (S[A] IN Set)) (*OR (S[A] = CHR(10))  *)THEN
      ScrollUp3(1);
      END;
     CurY:=ScrDat.Depth;
     YWidth:=CurY*ScrDat.Width;
     Cor:=A+1;
     CurX:=0;
     DoCursor;
    ELSE
     IF S[A] IN Set THEN
      INC(CurX,A-Cor);
      GotoXY(CurX,CurY);
      Cor:=A+1;
      WriteC(S[A]);
      YWidth:=CurY*ScrDat.Width;
     ELSE
      Screen^[CurX+A-Cor+YWidth]:=ORD(S[A])+ CARDINAL(TColor)<<8;
      END;
     END;
    INC(A);
    IF A>=B THEN
     EXIT
     END;
    END;
   END;
  END;
 CurX:=CurX + Tot-Cor;                 (* update cursor, Cor is correction for
                                          unusual effects, like wrapping etc *)
 WrapScreen;                           (* Scroll screen when necessary*)
END StrWithCursor;

PROCEDURE ConvertMode(Mode:CARDINAL);
(* Stand alone routine, convert screens between BIOS-modi. Current mode to
    mode 'Mode' and copy screens as far as possible, and clear unused screen
    space *)

TYPE TStor= ARRAY[0..8191] OF CARDINAL;

VAR OX,OY : CARDINAL;                   (* Old dimensions *)

    Fb,Cb : CARDINAL;                   (* Fb=Bytes to fill(at end of line)
                                           Cb=Bytes to copy per line *)
    (*# save, data(near_ptr=> off) *)
    PStor : POINTER TO TStor;           (* Temporary storage, always FAR *)
    (*# restore *)
    A     : CARDINAL;                   (* Counter *)

BEGIN
 FarAllocate(PStor,SIZE(TStor));

 (* Move screen to buffer *)

 FarWordMove(FarADR(Screen^[0]),FarADR(PStor^[0]),8192);

 OX:=ScrDat.Width;            OY:=ScrDat.Depth; (* Save old screensize*)
 ChangeMode(128+Mode);        (* Changemode, 128 means don't clear screen,
                                  (EGA+) *)
 Detect;                      (* Detect new screensizes *)

 IF OX<ScrDat.Width THEN      (* Calculate how many lines and columns can *)
  Cb:=OX;                     (*    be copied, *)
  Fb:=ScrDat.Width-OX;        (* clear the rest *)
 ELSE
  Fb:=0;
  Cb:=ScrDat.Width;
  END;
 ClrScr;                      (* Clear the screen *)
 FOR A := 0 TO ScrDat.Depth DO (* Copy line for line *)
  IF A<(OY+1) THEN
   FarWordMove(FarADR(PStor^[A*OX]),FarADR(Screen^[A*ScrDat.Width]),Cb);
   IF Fb>0 THEN
    FarWordFill(FarADR(Screen^[A*ScrDat.Width+Cb]),(ScrDat.Width-Cb),CARDINAL(TColor)<<8);
    END;
  ELSE
   FarWordFill(FarADR(Screen^[A*ScrDat.Width]),ScrDat.Width,CARDINAL(TColor)<<8);
   END;
  END;
 FarDeallocate(PStor,SIZE(TStor)); (*  Release tempory storage *)
END ConvertMode;

PROCEDURE CrtOn;   (* Activate CRT Module, use Detect when necessary,
                      e.g. in case of a page-switch/mode-change *)

BEGIN
 IF NOT CrtActive THEN
  ToCursor;                             (* Get BIOS-cursor to own regs  *)
  OldProc:=IO.WrStrRedirect;            (* Redirect WrStr to own routine *)
  IO.WrStrRedirect:=StrWithCursor;      (* StrWithCursor*)
  OldPrompt:=IO.Prompt;                 (* Otherwise a "?" is showed when *)
  IO.Prompt:=FALSE;                     (* IO.RdStr is used, IO solves this
                                           internally with the LWW global
                                           boolean, check IO source for details *)
  CrtActive:=TRUE;                      (* Mainmodules can check if Crt is active
                                           with this variable *)
  END;
END CrtOn;

PROCEDURE CrtOff;    (* Deactivate CRT Module, pass on control to BIOS/DOS*)

BEGIN
 IF CrtActive THEN
  IO.WrStrRedirect:=OldProc;    (* Reverse of CrtOn, see comments there *)
  IO.Prompt:=OldPrompt;
  CrtActive:=FALSE;
  DoCursor;                     (* Get the CRT-cursor, and set the BIOS-cursor
                                   accordingly *)
  END;
END CrtOff;

PROCEDURE Detect;
(* Locate address of the screen and its sizes *)

VAR R : VgaNfoT;
    A : CARDINAL;

BEGIN
 GetVgaData(R);          (* Get data from BIOS/VGAcard,
                            needed for number of rows cause BIOS-data area
                            is crippled on some cards (ET4000 clones) *)
 ScrDat.Width           :=R.Width;
 ScrDat.Depth           :=CARDINAL(R.Rows)-1;
 ScrDat.Regen           :=R.Regen;
 IF ScrDat.Regen>08000H THEN
  ScrDat.Regen:=08000H;         (* Never use more than 32k, danger of
                                   overwriting device drivers or page-frame *)
  END;
(*IF TestForDV THEN
  DetectDV;
  END;       *)          (* DesqView detection disabled, doesn't work *)
 A:=R.RegenOfs;          (* Offset in regen, >0 when videopage>0 *)
 INC(A,ScreenOfs);       (* add segment of address screen,
                            specially for virtual screens which don't have to
                            start on offset=0*)
 IF A>08000H THEN        (* Can't write past 32k *)
  A:=0;                  (* Error, default use begin screensegment *)
  SetPage(0);            (* Default screenpage 0 *)
  END;
 Screen:=[ScreenSeg:A];  (* Screen points to position (0,0) on the screen*)
END Detect;

BEGIN (* Set default and  initialize Crt*)
 CrtActive:=FALSE;                    (* Crt not active at this point *)
 TestForDV:=FALSE;                    (* No DesqView detection, not ready*)
 TrapAnsi:=FALSE;                     (* Default, don't install ANSIhandling*)
 ScreenOfs:=ORD(CardDetect());        (* Detect videocard*)
 IF ScreenOfs<7 THEN                  (* No VGA ?*)
  IO.WrStr("No VGA!");
  HALT;                               (* VGA required*)
 ELSIF ScreenOfs=7 THEN
  ScreenSeg:=0B000H;                  (* Mono VGA*)
 ELSE
  ScreenSeg:=0B800H;                  (* Color VGA*)
  END;
 ScreenOfs:=0;                        (* Default, Screen starts at the beginning
                                        of the screensegment *)
 Detect;                              (* Detect screensizes etc *)
 CrtOn;                               (* Crt becomes active, IO-screenroutines
                                          redirected *)
 BlinkOff;                            (* BlinkOff, high-colors(8..15) on *)
 TextColor     (CoreCrt.Cyan);
 TextBackground(CoreCrt.Black);
END Crt.
