IMPLEMENTATION MODULE HelpSystem;

FROM Storage IMPORT ALLOCATE,DEALLOCATE;
FROM ELib    IMPORT GetKey,KillChar,KillBChar,KillChrTot;
FROM Lib     IMPORT ScanR,Move,Fill;
FROM DJArc   IMPORT Unpacker;
FROM Str     IMPORT Slice,CharPos,Copy,Length,CHARSET,Compare,Caps,Item,Append;
FROM CoreEFIO IMPORT Rd16,Rd24,Rd32;
IMPORT FIO,IO,Window;

TYPE FileBuffer = ARRAY[0..4095] OF BYTE;
     ShortStr   = ARRAY[0..100] OF CHAR;
     SStrPtr    = POINTER TO ShortStr;
     Buffer     = ARRAY[0..20000] OF BYTE;

   (* The main type, a Label; characterized by :*)

     Label      = RECORD
                   Ind     : LONGCARD; (* Fileposition(-header) in
                                          .HLP file of the text*)
                   Label   : ARRAY[0..39] OF CHAR; (* Its name.*)
                   END;
     Redirect   = RECORD
                   Label : CARDINAL;
                   HelpFile,
                   ForeignLabel : ARRAY[0..20] OF CHAR;
                   END;
     RedirectArr   = ARRAY[0..1000] OF Redirect;
     LabArr     = ARRAY[0..1300] OF Label;
     LabPtr     = POINTER TO LabArr;
     BufPtr     = POINTER TO Buffer;
     RedirPnt      = POINTER TO RedirectArr;

    HelpItemData= RECORD
                   NrLabs  : CARDINAL;  (* Nr of labels in data *)
                   Size    : CARDINAL;  (* Size of current text *)
                   NrExcl  : CARDINAL;  (* Nr of exclamation marks in data*)
                   LabStart,            (* First label in a block*)
                   ExclPos : ARRAY[0..25] OF CARDINAL; (* positions of Excls*)
                   LabPos,
                   LabX,LabY: ARRAY[0..250] OF CARDINAL; (* offsets and
                                                            coordinates on
                                                            the screen*)
                   END;
     TotR = RECORD
             Labs       : CARDINAL;
             RedNr      : CARDINAL;
             L          : LabPtr;
             Red        : RedirPnt;
             F          : FIO.File;
             Compress   : BOOLEAN;
             FBuf       : FileBuffer;
             END;
     HlpHandle=POINTER TO TotR;

CONST
      EscS=166;
      Min=40;
      Range=255-40;
             (* Some key-codes, as returned by GetKey*)

     ESC    =    1BH;      ArrU   = 04800H;     ArrL   = 04B00H;                    ArrR   = 04D00H;
     ArrD   = 05000H;      CR     =     13;     F1     = 3B00H;                     PgUp   = 04900H;
     PgDn   = 05100H;

VAR
    Buf,Buf2    : BufPtr;     (* These two pointers are allocate/deallocated
                                 in all kinds of temporary bufffers*)
    LastLabel   : CARDINAL;


PROCEDURE FindInPath( File : ARRAY OF CHAR; VAR FullName : ARRAY OF CHAR );
VAR
   ItemA         : CARDINAL;
   Found, NoMore : BOOLEAN;
BEGIN
   ItemA  := 0;
   Found  := FALSE;
   NoMore := FALSE;
   REPEAT
    Item( FullName, SearchPath, CHARSET{';'}, ItemA );
    IF Length( FullName ) = 0 THEN
     NoMore := TRUE;
    ELSE
    IF FullName[Length(FullName)-1] # '\' THEN
     Append( FullName, '\' );
     END;
     Append( FullName, File );
     Found := FIO.Exists( FullName );
     END;
    INC( ItemA );
    UNTIL Found OR NoMore;
END FindInPath;

PROCEDURE ParseTextBuffer(VAR R:HelpItemData;Siz:CARDINAL);

VAR A,B : CARDINAL;

BEGIN
 Fill(ADR(R),SIZE(R),0);
 A:=0;
 R.Size:=Siz;
 R.NrExcl:=0;   R.ExclPos[0]:=0;
 LOOP
  LOOP
   B:=ScanR(ADR(Buf^[A]),Siz-A,"!");
   IF B>(Siz-A-1) THEN
    EXIT
    END;
   IF Buf^[A+B-1] = BYTE(13) THEN
    EXIT
    END;
    A:=B+A+1;
   END;
  IF B>(Siz-A-1) THEN
   EXIT
   END;
  INC(R.NrExcl);
  R.ExclPos[R.NrExcl]:=B+A;
  A:=B+A+1
  END;
 A:=0;
 R.NrLabs:=0;
 LOOP
  B:=ScanR(ADR(Buf^[A]),Siz-A,CHR(EscS));
  IF B>(Siz-A-1) THEN
   EXIT
   END;
  R.LabPos[R.NrLabs]:=B+A;
  INC(R.NrLabs);
  A:=B+A+2;
  END;
 INC( R.NrExcl);
 R.ExclPos[R.NrExcl]:=Siz;
 IF R.NrExcl#0 THEN
  FOR A:=0 TO R.NrExcl-1 DO
   B:=0;
   LOOP
    IF B=R.NrLabs THEN
     EXIT
     END;
    IF (R.LabPos[B]>R.ExclPos[A]) AND (R.LabPos[B]<R.ExclPos[A+1]) THEN
     R.LabStart[A]:=B+1;
     EXIT;
     END;
    INC(B);
   END;
  END;
 END;
 R.LabStart[R.NrExcl]:=R.NrLabs+1;
END ParseTextBuffer;

PROCEDURE ParseRedirectBuf(Siz:CARDINAL;Red:RedirPnt);

VAR A,B,C : CARDINAL;
    Nr     : CARDINAL;
    S   : ARRAY[0..200] OF CHAR;

BEGIN
 DEC(Siz,2);
 A:=0;
 Nr:=0;
 LOOP
  B:=ScanR(ADR(Buf^[A]),Siz-A,CHR(145));
  INC(B,A);
  IF B>(Siz-1) THEN
   EXIT
   END;
  IF B=0 THEN
   EXIT
   END;
  Move(ADR(Buf^[A]),ADR(S),B-A);
  S[B-A]:=CHR(0);
  C:=CharPos(S,CHR(146));
  IF C#MAX(CARDINAL) THEN
   Slice(Red^[Nr].ForeignLabel,S,C+1,Length(S)-C+1);
   S[C]:=CHR(0);
   END;
  Copy(Red^[Nr].HelpFile,S);
  A:=B+1;
  INC(Nr);
  END;
END ParseRedirectBuf;

PROCEDURE FindLabel(Hlp:HlpHandle;Label : ARRAY OF CHAR):CARDINAL;

VAR S : ARRAY[0..100] OF CHAR;
    A,B : CARDINAL;
    L : LabPtr;

BEGIN
 Caps(Label);
 KillChar(Label,CHARSET{" ","!"});
 KillBChar(Label,CHARSET{" ","!"});
 KillChrTot(Label,CHARSET{" "});
 L:=Hlp^.L;
 B:=Hlp^.Labs;
 IF B>0 THEN
  FOR A :=0 TO B-1 DO
   Copy(S,L^[A].Label);
   KillChar(S,CHARSET{" ","!"});
   KillBChar(S,CHARSET{" ","!"});
   KillChrTot(S,CHARSET{" "});
   Caps(S);
   IF Compare(S,Label)=0 THEN
    RETURN A;
    END;
   END;
  END;
 RETURN MAX(CARDINAL);
END FindLabel;

PROCEDURE QuickWrite(VAR S : ARRAY OF BYTE;Len:CARDINAL;FirstLab:CARDINAL;VAR R :HelpItemData;L:LabPtr);

VAR A : CARDINAL;
    RedFlag : BOOLEAN;
    Cadre  : BOOLEAN;
    X,Y : CARDINAL;
    B : CARDINAL;
    Lab : CARDINAL;
                          (*    *)
BEGIN                     (*    *)
 A:=0;
 X:=0;
 Y:=0;
 Lab:=FirstLab;
 RedFlag:=FALSE; Window.TextColor(Col.Text);
 Cadre:=FALSE;
 LOOP
  IF A>(Len-1) THEN
   EXIT
   END;
  CASE S[A] OF
   | "!"                 : IF S[A+1]=BYTE(13) THEN
                           ELSE
                            IO.WrChar(CHR(A));
                            END;
   | BYTE(167),BYTE(168) : IO.WrCharRep(" ",ORD(S[A])-165);
                           INC(X,ORD(S[A])-165);
   | BYTE(169)           : IO.WrCharRep(" ",ORD(S[A+1])-167);
                           INC(X,ORD(S[A+1])-167); INC(A);
   | BYTE(170),BYTE(171) : IO.WrCharRep("",ORD(S[A])-168);
                           INC(X,ORD(S[A])-168);
   | BYTE(172)           : IO.WrCharRep("",ORD(S[A+1])-170);
                           INC(X,ORD(S[A+1])-170);
                           INC(A);
   | BYTE(166)           : Window.TextColor(Col.Label);
                           B:=(CARDINAL(S[A+1])-Min)+(CARDINAL(S[A+2])-Min)*Range;
                           IO.WrStr(L^[B].Label);
                           R.LabX[Lab]:=X;
                           R.LabY[Lab]:=Y;
                           INC(Lab);
                           Window.TextColor(Col.Text);
                           INC(X,Length(L^[B].Label));
                           INC(A,2);

   | BYTE(3)             : IF RedFlag THEN
                            RedFlag:=FALSE;
                            Window.TextColor(Col.Text);
                           ELSE
                            RedFlag:=TRUE;
                            Window.TextColor(Col.Text3);
                            END;

   | BYTE(13):             RedFlag:=FALSE; Window.TextColor(Col.Text);
                           INC(Y);
                           IF X < 64 THEN
                            IO.WrCharRep(" ",63-X);
                            END;
                           IF Cadre AND (S[A-1] # BYTE(218)) THEN
                            IO.WrChar(CHR(179));
                            END;

                           X:=0;
                           IF Y #18 THEN
                            IO.WrLn;
                            END;
                           IF Cadre AND (S[A+1] # BYTE(192)) THEN
                            IO.WrChar(CHR(179));
                            X:=1;
                            END;

   | BYTE(218):            IO.WrChar(CHR(218));
                           IF S[A+1] = BYTE(13) THEN
                            IO.WrCharRep("",62);
                            IO.WrChar(CHR(191));  Cadre:=TRUE;
                            X:=64;
                            END;
   | BYTE(192):            IO.WrChar(CHR(192));
                           IF S[A-1] =BYTE(13) THEN
                            IO.WrCharRep("",62);
                            Cadre:=FALSE; X:=63;
                            IO.WrChar(CHR(217));
                            END;
                            INC(X);

   ELSE
    IO.WrChar(S[A]);
    INC(X);
    END;
   IF X>100 THEN
    HALT;
    END;
   INC(A);
   END;
END QuickWrite;

PROCEDURE ParseLabelBuffer(Size:CARDINAL;L:LabPtr);

VAR A,B,C : CARDINAL;
    S     : SStrPtr;
    S2    : ARRAY[0..50] OF CHAR;

BEGIN
 B:=0;
 C:=0;
 LOOP
  S:=ADR(Buf^[C]);
  IF C=0 THEN
   Slice(S2,S^,0,50);
  ELSE
   Slice(S2,S^,1,50);
   END;
  A:=CharPos(S2,CHR(145));
  IF A <Size THEN
   S2[A]:=CHR(0);
   END;
  Copy(L^[B].Label,S2);
  Buf^[C]:=CHR(32);
  C:=ScanR(ADR(Buf^[0]),Size,CHR(145));
  IF C> (Size-1) THEN
   EXIT
   END;
  INC(B);
  END;
END ParseLabelBuffer;

PROCEDURE InitHelpFile(Name : ARRAY OF CHAR):HlpHandle;

VAR A,
    ComprSize,
    BufInd : CARDINAL;
    Index : LONGCARD;
    RT    : HlpHandle;
    F     : FIO.File;
    S     : FIO.PathStr;

BEGIN
 FindInPath(Name,S);
 IF Length(S)<1 THEN
  RETURN NIL;
  END;
 NEW(RT);
 NEW(Buf2); NEW(Buf);
 RT^.F:=FIO.Open(S);
 F:=RT^.F;
 FIO.AssignBuffer(F,RT^.FBuf);
 Index:=Rd32(RT^.F);
 RT^.Compress:=BOOLEAN(FIO.RdChar(F));
 IF FIO.RdChar(F)#CHR(255) THEN
  DISPOSE(Buf);
  DISPOSE(Buf2);
  FIO.Close(F);
  DISPOSE(RT);
  IO.WrStr("Helpfile "); IO.WrStr(Name);IO.WrStr(" not found or not valid");
  IO.WrLn;
  HALT;
  END;
 FIO.Seek(F,Index+16);
 RT^.Labs:=Rd16(F);
 ALLOCATE(RT^.L,RT^.Labs*SIZE(Label));
 BufInd:=Rd16(F);
 ComprSize:=Rd16(F);
 FOR A:=0 TO RT^.Labs-1 DO            (* Read "Labs" indices *)
  RT^.L^[A].Ind:=LONGCARD(Rd24(F));
  END;
 A:=FIO.RdBin(F,Buf2^[0],ComprSize);
 IF RT^.Compress THEN
  Unpacker(BufInd,ADR(Buf2^[0]),ADR(Buf^[0]));
 ELSE
  A:=BufInd;
  Move (ADR(Buf2^[0]),ADR(Buf^[0]),A);
  END;
 ParseLabelBuffer(BufInd,RT^.L);
 RT^.RedNr:=Rd16(F);
 IF RT^.RedNr>0 THEN
  ALLOCATE(RT^.Red,(1+RT^.RedNr)*SIZE(Redirect));
  BufInd:=Rd16(F);
  ComprSize:=Rd16(F);
  FOR A:=0 TO RT^.RedNr-1 DO            (* Read "Labs" indices *)
   RT^.Red^[A].Label:=Rd16(F);
   END;
  Fill(ADR(Buf^[0]),100,0);
  A:=FIO.RdBin(F,Buf2^[0],ComprSize);

  IF RT^.Compress THEN
   Unpacker(BufInd,ADR(Buf2^[0]),ADR(Buf^[0]));
  ELSE
   A:=BufInd;
   Move (ADR(Buf2^[0]),ADR(Buf^[0]),A);
   END;
  ParseRedirectBuf(BufInd,RT^.Red);
  END;

 DISPOSE(Buf2);
 DISPOSE(Buf);
 RETURN RT;
END InitHelpFile;

(*
PROCEDURE WrR(R:HelpItemData);
Debug function, I stil need it when I do big changes to

VAR F2 : FIO.File;
    A  : CARDINAL;

BEGIN
 F2:=FIO.Create("r.Dat");
 FIO.WrStr(F2,"Size     :"); FIO.WrCard(F2,R.Size,5); FIO.WrLn(F2);
 FIO.WrStr(F2,"NrExcl   :"); FIO.WrCard(F2,R.NrExcl,5); FIO.WrLn(F2);
 FIO.WrStr(F2," Nr   ExclPos LabStart :"); FIO.WrLn(F2);
 FOR A :=0 TO R.NrExcl+1 DO
  FIO.WrCard(F2,A,5);
  FIO.WrCard(F2,R.ExclPos[A],5);
  FIO.WrCard(F2,R.LabStart[A],5);
  FIO.WrLn(F2);
  END;
 FIO.WrLn(F2);
 FIO.WrStr(F2,"NrLabs   :"); FIO.WrCard(F2,R.NrLabs,5); FIO.WrLn(F2);
 FIO.WrStr(F2," Nr   LabPos LabX LabY:"); FIO.WrLn(F2);
 FOR A:=0 TO R.NrLabs+1 DO
  FIO.WrCard(F2,A,5);
  FIO.WrCard(F2,R.LabPos[A],5);
  FIO.WrCard(F2,R.LabX[A],5);
  FIO.WrCard(F2,R.LabY[A],5);
  FIO.WrLn(F2);
  END;
 FIO.Close(F2);
END WrR; *)

PROCEDURE WrBlock(VAR R :HelpItemData;VAR Block:CARDINAL;L:LabPtr);

VAR A,B : CARDINAL;

BEGIN
 IF Block>(R.NrExcl-1) THEN
  Block:=R.NrExcl-1;
  END;
 Window.Clear;
 Window.GotoXY(1,1);
 A:=R.LabStart[Block]-1;
 IF A=MAX(CARDINAL) THEN
  A:=0;
  END;
 QuickWrite(Buffer(Buf^[R.ExclPos[Block]]),R.ExclPos[Block+1]-R.ExclPos[Block],A,R,L);
END WrBlock;

PROCEDURE LoadTextForLabel(RT:HlpHandle;LabelNr: CARDINAL;VAR R : HelpItemData);

PROCEDURE ReadText(N:CARDINAL):CARDINAL;
(* Decomp text of record N to Buf^, Returns length.
   Buf2^ used! *)

VAR Compr,UnCompr : CARDINAL;
    NrRead        : CARDINAL;
    F             : FIO.File;

BEGIN
 NEW(Buf2);
 F:=RT^.F;
 FIO.Seek(F,16+RT^.L^[N].Ind);
 UnCompr:=Rd16(F);
 Compr:=Rd16(F);
 NrRead:=FIO.RdBin(F,Buf2^[0],Compr);
 IF RT^.Compress THEN
  Unpacker(UnCompr,ADR(Buf2^[0]),ADR(Buf^[0]));
 ELSE
  UnCompr:=Compr;
  Move (ADR(Buf2^[0]),ADR(Buf^[0]),Compr);
  END;
 DISPOSE(Buf2);
 RETURN UnCompr;
END ReadText;

VAR InBuf : CARDINAL;

BEGIN
 LastLabel:=LabelNr;
 InBuf:=ReadText(LabelNr);
 ParseTextBuffer(R,InBuf); (* Also saves InBuf *)
END LoadTextForLabel;

PROCEDURE DoHelp(Hlp:HlpHandle;LoadLabel:CARDINAL;VAR Return : CARDINAL):CARDINAL;

CONST MemSize = 25;

VAR A,B,C,
    Key,
    Block,
    CurLab    : CARDINAL;
    EmptyMenu : BOOLEAN;
    MemArr    : ARRAY[0..25] OF CARDINAL;
    R         : HelpItemData;

PROCEDURE Hilight(Hil:BOOLEAN);

VAR A2,B2 :CARDINAL;

BEGIN
 EmptyMenu:=(R.LabStart[Block] =0);
 IF NOT EmptyMenu THEN
  Window.GotoXY(R.LabX[CurLab]+1,R.LabY[CurLab]+1);
  IF Hil THEN
   Window.TextBackground(Col.LabelHighBack);
   Window.TextColor(Col.LabelHigh);
  ELSE
   Window.TextBackground(Col.TextBack);
   Window.TextColor(Col.Label);
   END;
  WITH R DO
   A2:=LabPos[CurLab]+1(*LabStart[Block]] *);
   END;
  B2:=CARDINAL(Buf^[A2]-BYTE(Min))+CARDINAL(Buf^[A2+1]-BYTE(Min))*Range;
  IO.WrStr(Hlp^.L^[B2].Label);
  Window.TextBackground(Col.TextBack);
  Window.TextColor(Col.Text);
  END;
END Hilight;

PROCEDURE FindDown(A3:CARDINAL):CARDINAL;

VAR B2 :CARDINAL;

BEGIN
 B2:=A3;
 LOOP
  IF B2> (R.NrLabs-1) THEN
   RETURN B2-1;
   END;
  IF R.LabY[A3]#R.LabY[B2] THEN
   RETURN B2;
   END;
  INC(B2);
  END;
END FindDown;

PROCEDURE FindUp(A1:CARDINAL):CARDINAL;

VAR B2 :CARDINAL;

BEGIN
 B2:=A1;
 LOOP
  IF B2=0 THEN
   RETURN 0;
   END;
  DEC(B2);
  IF R.LabY[A1]#R.LabY[B2] THEN
   RETURN B2+1;
   END;
  END;
END FindUp;

PROCEDURE DoBlock;

BEGIN
 EmptyMenu:=(R.LabStart[Block] =0);
 WrBlock(R,Block,Hlp^.L);
END DoBlock;

PROCEDURE Push(In:CARDINAL);

VAR A1,B1:CARDINAL;

BEGIN
 FOR A1:=24 TO 0 BY -1 DO
  MemArr[A1+1]:=MemArr[A1];
  END;
 MemArr[0]:=In;
END Push;

PROCEDURE Pop():CARDINAL;

VAR A1,B1:CARDINAL;

BEGIN
 B1:=MemArr[0];
 FOR A1:=0 TO 24  DO
  MemArr[A1]:=MemArr[A1+1];
  END;
 MemArr[25]:=MAX(CARDINAL);
 RETURN B1;
END Pop;

BEGIN
 NEW(Buf);
 LoadTextForLabel( Hlp,LoadLabel,R);
 Fill(ADR(MemArr),SIZE(MemArr),0FFH);
 EmptyMenu:=FALSE;
 Block:=0;
 CurLab:=0;
 DoBlock;
 Hilight(TRUE);
 LOOP
  Key:=GetKey();
  CASE Key OF
    ArrL : IF NOT EmptyMenu THEN
            IF CurLab>(R.LabStart[Block]-1) THEN
             Hilight(FALSE);
             DEC(CurLab);
            ELSIF Block>0 THEN
             DEC(Block);
             DEC(CurLab);
             DoBlock;;
             END;
            Hilight(TRUE);
            END;
  | ArrR : IF NOT EmptyMenu THEN
            IF CurLab<(R.LabStart[Block+1]-2) THEN
             Hilight(FALSE);
             INC(CurLab);
             Hilight(TRUE);
            ELSIF Block<(R.NrExcl-1) THEN
             INC(Block);
             INC(CurLab);
             DoBlock;;
             END;
            Hilight(TRUE);
            END;
  | ArrD :  IF EmptyMenu THEN
             IF Block<(R.NrExcl+1) THEN
              INC (Block);
              IF R.LabStart[Block]#0 THEN
               CurLab:=R.LabStart[Block]-1;
               END;
              DoBlock;
              Hilight(TRUE);
              END;
           ELSE
             Hilight(FALSE);
             A:=FindUp(CurLab);
             A:=CurLab-A;
             B:=FindDown(CurLab);
             C:=FindDown(B)-B-1;
             IF (C>A) OR (C=A) THEN
              CurLab:=B+A;
             ELSE
              CurLab:=C+B;
              END;
             IF (CurLab)>(R.LabStart[Block+1]-2)THEN
              INC(Block);
              DoBlock;;
              END;
            IF CurLab>(R.NrLabs-1) THEN
              CurLab:=R.NrLabs-1;
              END;
             Hilight(TRUE);
            END;
  | PgDn :  IF Block<(R.NrExcl-1) THEN
             INC(Block);
             CurLab:=R.LabStart[Block]-1;
             DoBlock;
             Hilight(TRUE);
             END;
  | PgUp :  IF Block=0 THEN
             A:=Pop();
             IF A# MAX(CARDINAL) THEN
              LoadTextForLabel(Hlp,A,R);
              Block:=0;
              CurLab:=0;
              DoBlock;
              Hilight(TRUE);
              END;
            ELSE
             DEC(Block);
             CurLab:=R.LabStart[Block]-1;
             DoBlock;
             Hilight(TRUE);
             END;
  | ArrU :  IF EmptyMenu THEN
             IF Block>0 THEN
              DEC (Block);
              IF R.LabStart[Block]#0 THEN
               CurLab:=R.LabStart[Block]-1;
               END;
              DoBlock;
              Hilight(TRUE);
              END;
            ELSE
             Hilight(FALSE);
             A:=FindUp(CurLab);
             B:=FindUp(A-1);
             C:=CurLab-A;
             IF (B>1000) AND (Block>0) THEN
              DEC(Block);
              DoBlock;
             ELSE
               IF (C+1)>(A-B) THEN
                CurLab:=B+A-1-B;
               ELSE
                CurLab:=B+C;
                END;
               IF CurLab>(1000) THEN
                CurLab:=C;
                END;
               IF (Block>0) AND (CurLab<(R.LabStart[Block])-1) THEN
                DEC(Block);
                DoBlock;;
                END;
               Hilight(TRUE);
              END;
             END;
  | CR :    IF NOT EmptyMenu THEN
             Push(LastLabel);
             A:=R.LabPos[CurLab]+1;
             B:=CARDINAL(Buf^[A]-BYTE(Min))+CARDINAL(Buf^[A+1]-BYTE(Min))*Range;
             FOR A:=0 TO Hlp^.RedNr-1 DO
              IF B=Hlp^.Red^[A].Label THEN
                Return:=A;
                DISPOSE(Buf);
                RETURN 1;
                END;
              END;
             LoadTextForLabel(Hlp,B,R);
             Block:=0;
             CurLab:=0;
             DoBlock;
             Hilight(TRUE);
             END;
  | F1  :    LoadTextForLabel(Hlp,0,R);
             Block:=0;
             CurLab:=0;
             DoBlock;
             Hilight(TRUE);
  | ESC :    EXIT;
   END;
  END;
  DISPOSE(Buf);
  RETURN 0;
END DoHelp;

PROCEDURE MainHelpFunc(Hlp:HlpHandle;LoadLabel:CARDINAL):CARDINAL;

VAR    S           : ARRAY[0..255] OF CHAR;

PROCEDURE SmallHelpFunc(HlpFrom:HlpHandle;Lab:CARDINAL;VAR Ret:CARDINAL):CARDINAL;

VAR A,B,C : CARDINAL;
    Hlp3: HlpHandle;

BEGIN
   FindInPath(HlpFrom^.Red^[Lab].HelpFile,S);
   IF Length(S)>0 THEN
    Hlp3:=InitHelpFile(S);
    B:=FindLabel(Hlp3,HlpFrom^.Red^[Lab].ForeignLabel);
    LOOP
     A:=DoHelp(Hlp,B,C);
     IF A = 0 THEN
      EXIT
      END;
     IF A=1 THEN
      A:=SmallHelpFunc(Hlp3,C,B);
      END;
     END;
    RemoveHelpFile(Hlp3);
   ELSE
    Window.TextBackground(Red);
    Window.TextColor(White);
    Window.Clear;
    IO.WrLn;
    IO.WrLn;
    IO.WrStr("  Helpfile :");
    IO.WrStr(Hlp^.Red^[Ret].HelpFile);
    IO.WrStr(" not found!");
    IO.WrLn;
    IO.WrLn;
    IO.WrStr(" Press enter to continue.");
    IO.WrLn;
    REPEAT
     B:=GetKey();
    UNTIL B=CR;
    Window.TextBackground(Col.TextBack);
    Window.Clear;
    END;
RETURN 0;
END SmallHelpFunc;


VAR W           : Window.WinType;
    A,B,Ret     : CARDINAL;
    WD          : Window.WinDef;
    Hlp2        : HlpHandle;


BEGIN
 WITH WD DO
  X1:=5; X2:=72; Foreground:=Col.Text;        CursorOn:=FALSE; WrapOn:=FALSE;
  Y1:=1; Y2:=21; Background:=Col.TextBack;    Hidden :=FALSE;
  FrameOn:=TRUE; FrameFore:=Col.FrameFore; FrameBack:=Col.TextBack;
  FrameDef:=Window.DoubleFrame;
  END;
 W:=Window.Open(WD);
 Window.Use(W);
 Window.SetTitle (W," XtdHlp Help, by Marco van de Voort",Window.CenterUpperTitle);
 REPEAT
  A:=DoHelp(Hlp,LoadLabel,Ret);
  IF A=1 THEN
   B:=SmallHelpFunc(Hlp,Ret,A);
   END;
 UNTIL A=0;
 Window.Close(W);
RETURN 0;
END MainHelpFunc;

PROCEDURE RemoveHelpFile(Hlp:HlpHandle);

BEGIN
 FIO.Close(Hlp^.F);
 DEALLOCATE(Hlp^.Red,(1+Hlp^.RedNr)*SIZE(Redirect));
 DEALLOCATE(Hlp^.L,Hlp^.Labs*SIZE(Label));
 DISPOSE(Hlp);
END RemoveHelpFile;
(*68 x 21 *)

BEGIN
 SearchPath:="."; LastLabel:=0;
END HelpSystem.
