IMPLEMENTATION MODULE ModAsm;

IMPORT FIO,IO;
FROM IO IMPORT KeyPressed,RdKey;
FROM Str IMPORT Length,Concat,Append,Delete,CHARSET,Copy,Caps,Pos,Insert,CharPos,Item,Prepend;
FROM Lib IMPORT PSP,EnvironmentFind,Delay,Move;
FROM SYSTEM IMPORT In,Out;

PROCEDURE StrStr(VAR S:ARRAY OF CHAR;Char:CHAR;Num:CARDINAL);

VAR A : CARDINAL;

BEGIN
 IF Num>HIGH(S) THEN
  Num:=HIGH(S);
  END;
 FOR A:=0 TO Num-1 DO
  S[A]:=Char;
  END;
END StrStr;

PROCEDURE LGrow(VAR St1:ARRAY OF CHAR;Char:CHAR;TotSize:CARDINAL);
(* Asm version has more checks on HIGH St1 etc *)

VAR A:CARDINAL;
    B: ARRAY[1..1000] OF CHAR;

BEGIN
 IF (TotSize-Length(St1))>0 THEN
  StrStr(B,Char,TotSize-Length(St1));
  Concat(St1,B,St1);
  END;
END LGrow;

PROCEDURE RGrow(VAR St1:ARRAY OF CHAR;Char:CHAR;TotSize:CARDINAL);
(* Asm version has more checks on HIGH St1 etc *)

VAR A:CARDINAL;

BEGIN
 IF (TotSize-Length(St1))>0 THEN
  FOR A:= 1 TO TotSize-Length(St1) DO
   Append(St1,Char);
   END;
  END;
END RGrow;

PROCEDURE KillChar(VAR InStr : ARRAY OF CHAR;C:CHARSET);

BEGIN
 WHILE (InStr[0] IN C) DO Delete(InStr,0,1); END;
END KillChar;

PROCEDURE KillBChar(VAR InSt:ARRAY OF CHAR;C :CHARSET);

BEGIN
 LOOP
  IF (InSt[Length(InSt)-1] IN C) AND (Length(InSt)>0) THEN
   Delete(InSt,Length(InSt)-1,1);
  ELSE
   EXIT;
   END;
  END;
END KillBChar;

PROCEDURE KillChrTot(VAR TmpStr:ARRAY OF CHAR;C:CHARSET);
VAR A:CARDINAL;

BEGIN
 FOR A:=0 TO HIGH(TmpStr)-1 DO
  IF TmpStr[A] IN C THEN
   Delete(TmpStr,A,1);
   END;
  END;
END KillChrTot;

PROCEDURE ReplaceChar(VAR InStr : ARRAY OF CHAR;C,C1:CHAR);

VAR A : CARDINAL;

BEGIN
 FOR A :=0 TO Length(InStr)-1 DO
  IF InStr[A]=C THEN
   InStr[A]:=C1;
   END;
  END;
END ReplaceChar;

PROCEDURE EnvFind(name: ARRAY OF CHAR;VAR result: ARRAY OF CHAR;Env:EnvRec);
(* Dirty, but very small version of MLib.EnvironmentFind below, not used.
Procedure changes PSP, uses original Lib.EnvironmentFind, and restores PSP. *)

VAR TEnv:CARDINAL;

BEGIN
 TEnv:=[PSP:2CH]^;
 [PSP:2CH]^:=Env.EnvSeg;
 EnvironmentFind(name,result);
 [PSP:2CH]^:=TEnv;
END EnvFind;

PROCEDURE WrCardAbs(F:FIO.File;C:CARDINAL) : CARDINAL;

VAR A :CARDINAL;

BEGIN
 IF (C > 9999) THEN
  A:=5;
 ELSIF(C > 999) THEN
  A:=4;
 ELSIF(C > 99) THEN
  A:=3;
 ELSIF(C > 9) THEN
  A:=2;
 ELSE
  A:=1;
  END;
 FIO.WrCard(F,C,0);
 RETURN A;
END WrCardAbs;

PROCEDURE GetKey():CARDINAL;

VAR GA : CARDINAL;
    Fl : BOOLEAN;
BEGIN
 LOOP
  IF KeyPressed() THEN
   GA:=ORD(RdKey());
   EXIT
   END;
  END;
  IF GA=0 THEN
   GA:=ORD(RdKey())<<8;
   END;
 RETURN GA;
END GetKey;

PROCEDURE Easter(Year : CARDINAL):CARDINAL;
   (* Easter date calculation, return=1 = 1 march; return=32= 1 april *)
VAR
   GoldenNo,
   Sun,
   Century,
   LeapCent,
   LunarCorr,
   Epact,
   FullMoon : INTEGER;
BEGIN
   Century := (Year DIV 100) + 1;
   LeapCent := (3 * Century DIV 4) - 12;
   LunarCorr := ((8 * Century + 5) DIV 25) - 5;
   GoldenNo := (Year MOD 19) + 1;
   Epact := 11 * GoldenNo + 20 + LunarCorr - LeapCent;
   Epact:=ABS(Epact ) MOD 30;
   Sun := (5 * INTEGER(Year) DIV 4) - LeapCent - 10;
   IF ((Epact = 25) AND (GoldenNo > 11)) OR (Epact = 24) THEN
    INC(Epact);
    END;
   FullMoon := 44 - Epact;
   IF FullMoon < 21 THEN
    INC(FullMoon, 30);
    END;
   RETURN FullMoon + 7 - ((Sun + FullMoon) MOD 7);
END Easter;

PROCEDURE DOW( Year,Month,Day:CARDINAL ): CARDINAL;
  (*  DOW( a Sunday)=0; DOW( a Monday)=1
      Ultrafast since it works with tables.
      Only works this century, but corrections are possible
      Do this by uncommenting " + Correction" , and replace it by

    Century     Correction
       18th     4
       19th     2
       20th     0
       21st     6

        Assembler version has correction build in for all centuries until
        the 255th or so. Use like ((Year DIV 100)+1) AND 3 as an index in the
        following table to obtain the correction:
            TYPE TabType=ARRAY[0..3] OF BYTE;
            CONST Tab=TabType(0,6,4,2);
       *)


TYPE  Arr12     =       ARRAY[1..12] OF BYTE;

CONST Tab       =       Arr12(0,3,3,6,1,4,6,2,5,0,3,5);

VAR     iVAR1,
        iVAR2    : CARDINAL;

BEGIN
 iVAR1 := Year MOD 100;
 iVAR2 :=  Day  + iVAR1 + iVAR1 DIV 4;
 iVAR2 := ( CARDINAL(Tab[Month]) + iVAR2 (* + Correction*)   ) MOD 7;
 RETURN iVAR2;
END DOW;

PROCEDURE ISqrt(A:INTEGER):INTEGER;

VAR C,B :INTEGER;

BEGIN
 B:=0;
 LOOP
  DEC(A,B*2+1);
  IF A<0 THEN
   EXIT
   END;
  INC(B);
  END;
 RETURN B;
END ISqrt;

CONST Wid=8;

PROCEDURE SizeChar(X,Y:CARDINAL):CARDINAL;

(* Calculate the size of a char, and round up on whole bytes. *)

BEGIN
 IF (X*Y) MOD Wid=0 THEN
  RETURN (X*Y) DIV Wid
 ELSE
  RETURN (X*Y) DIV Wid +1;
  END;
END SizeChar;

PROCEDURE SizeCharsetP(Fnt:FontR):CARDINAL;

(* Calculates the size of a packed font, in bytes *)

BEGIN
 IF (Fnt.DX*Fnt.DY*Fnt.NrOfChars) MOD Wid=0 THEN
  RETURN (Fnt.DX*Fnt.DY*Fnt.NrOfChars) DIV Wid
 ELSE
  RETURN (Fnt.DX*Fnt.DY*Fnt.NrOfChars) DIV Wid +1;
  END;
END SizeCharsetP;

PROCEDURE MirrorRow(Width : CARDINAL;VAR T: LongBitSet);

(* Mirror the first (lowest index) "Width" bits in a bitset *)

VAR T2:LongBitSet;
    R2:CARDINAL;

BEGIN
 FOR  R2:= 0 TO Width-1 DO
  IF R2 IN T THEN
   INCL(T2,Width-1-R2);
  ELSE
   EXCL(T2,Width-1-R2);
   END;
  END;
 T:=T2;
END MirrorRow;

PROCEDURE DayNr(year,month,day:CARDINAL):CARDINAL; (* Dummy procedure*)

BEGIN

RETURN 1;
END DayNr;

   PROCEDURE PhaseOfMoon(year,month,day:CARDINAL):CARDINAL;
   (* algorithm from TECO, or so says some people on the net *)
   CONST
     multiplier = 64;
   VAR
     century, golden, epact, period, eighth, sixteenth, phase :CARDINAL;
   BEGIN


       century := year DIV 100 + 1;
       golden  := (year MOD 19)  + 1;
       epact   := golden * 11 + 20 + ( (8 * century + 5) DIV 25 - 5) -  (3 * century DIV 4 - 12 );
       epact   := epact MOD 30;
       IF ( epact = 25 ) & ( golden > 11 ) THEN epact := 26; END;
       IF epact = 24 THEN epact := 25; END;
        RETURN epact;
       period := 29 * multiplier + multiplier DIV 2;    (*1888*)
       eighth := period DIV 8;                          (*236*)
       sixteenth := eighth DIV 2;                       (*118*)

       phase := ( DayNr(year,month,day ) + epact - 1 ) * multiplier + sixteenth;
       phase := phase MOD period;
       phase := phase DIV eighth;
       phase := phase MOD 8;
       RETURN phase;
   END PhaseOfMoon;

PROCEDURE SoundBlDetected():CARDINAL;
CONST AantalKeer1=10;
      AantalKeer2=50;

VAR Port  : CARDINAL;
    Found : BOOLEAN;
    Counter1,
    Counter2 : CARDINAL;

BEGIN
 Port :=0210H;
 Found:=FALSE;
 Counter1:=AantalKeer1;
 WHILE (Port<=0260H) AND NOT Found DO
  Out(Port+6,1);
  Out(Port+6,0);
  Counter2:=AantalKeer2;
  WHILE (Counter2>0) AND (In(Port+0EH)<128) DO
   DEC(Counter2);
   END;
  IF (Counter2=0) OR (In(Port+0AH) # 0AAH) THEN
   DEC(Counter1);
   IF Counter1=0 THEN
    Counter1:=AantalKeer1;
    INC(Port,010H);
    END;
   ELSE
    Found:=TRUE;
    END;
  END;

IF Found THEN
 RETURN Port;
ELSE
 RETURN 0
 END;
END SoundBlDetected;


PROCEDURE ResetAdlib;

BEGIN
(*   OutFM(020H,041H);
   OutFM(040H,010H);
   OutFM(060H,0F0H);
   OutFM(080H,077H);
   OutFM(023H,041H);
   OutFM(043H,000H);   m2 version of OutFM lost. I'll add it later.
   OutFM(063H,0F0H);
   OutFM(083H,077H);
   OutFM(0BDH,010H); *)
END ResetAdlib;

PROCEDURE reset_dsp() : BOOLEAN;

BEGIN

 (*{ calculate the port addresses }
 dsp_reset        := base + $206;
 dsp_read_data    := base + $20a;
 dsp_write_data   := base + $20c;
 dsp_write_status := base + $20c;
 dsp_data_avail   := base + $20e;

 { reset the dsp, and give some nice long delays just to be safe } *)
 Out(226H,1);
 Delay(10);

 Out(226H,0);
 Delay(10);

 IF (In(22EH) AND 080H = 80H) AND (In(022AH)=0AAH) THEN
  RETURN TRUE;
 ELSE
  RETURN FALSE;
  END;
END reset_dsp;


CONST    Writeport  = 022CH;
PROCEDURE SpeakerOn;
BEGIN
   REPEAT UNTIL In(Writeport) < 080H;
   Out(Writeport,0D1H);
END SpeakerOn;

PROCEDURE SpeakerOff;
BEGIN
   REPEAT UNTIL In(Writeport) < 80H;
   Out(Writeport,0D3H);
END SpeakerOff;

PROCEDURE DayofWeek( Year,Month,Day:CARDINAL ): CARDINAL;
  (* For this century only, corrections possible with :
    E. Add for century
       18th 4                   20th 0
       19th 2                   21st 6 *)


        TYPE Arr12=ARRAY[1..12] OF BYTE;
        CONST Tab=Arr12(0,3,3,6,1,4,6,2,5,0,3,5);
        VAR     iVAR1, iVAR2    : CARDINAL;

        BEGIN
                iVAR1 := Year MOD 100;
                (* Las hier evt de correctie berekening in,
                je hebt hier toch year DIV 100 *)
                iVAR2 :=  Day  + iVAR1 + iVAR1 DIV 4;
                iVAR2 := ( CARDINAL(Tab[Month]) + iVAR2 ) MOD 7;
                RETURN iVAR2;
END DayofWeek;

PROCEDURE WeekNr( Year, Month, Day : CARDINAL ) : CARDINAL;
VAR
   Week, Dow : CARDINAL;
BEGIN
   Dow := (ORD(DayofWeek( Year, 1, 1 ))+6) MOD 7; (* Set switchdate to Monday *)
   Week := ((DayNr( Year, Month, Day )+Dow-1) DIV 7);
   IF Dow < 4 THEN
      INC( Week );
   END;
   IF Week = 0 THEN
      Week := WeekNr( Year-1, 12, 31 );
   END;
   RETURN Week;
END WeekNr;

PROCEDURE ReplaceCI2(VAR S1:ARRAY OF CHAR;S2,S3:ARRAY OF CHAR);

VAR A:CARDINAL;
    S4 :ARRAY[0..30] OF CHAR;

BEGIN
 Copy(S4,S2);
 Caps(S4);
 LOOP
  A:=Pos(S1,S2);
  IF A = MAX(CARDINAL) THEN
   A:=Pos(S1,S4);
   END;
  IF A= MAX(CARDINAL) THEN
   EXIT
   END;
  Delete(S1,A,Length(S2));
  Insert(S1,S3,A);
  END;
END ReplaceCI2;


PROCEDURE WrAddr(Adx : ADDRESS);
VAR C : CHAR;

BEGIN
 C:=IO.PrefixChar;
 IO.PrefixChar:="0";
 IO.WrHex(Seg(Adx),4); IO.WrChar(":");IO.WrHex(Ofs(Adx),4);
 IO.PrefixChar:=C;
END WrAddr;

PROCEDURE NormalizeAddr(Adr : ADDRESS):ADDRESS;

VAR Sg,Of : CARDINAL;

BEGIN
Of:=Ofs(Adr);
Sg:=Seg(Adr)+(Ofs(Adr) AND 0FFF0H)>>4;
Of:=Of AND 15;
 RETURN ADR([Sg:Of]^);
END NormalizeAddr;

PROCEDURE GetSwitch(VAR S,S2:ARRAY OF CHAR):BOOLEAN;
(* the assembler version doesn't use a set, no Str.Delete, no Str.Append,
 only Str.CharPos*)

CONST Sep=CHARSET{"/"," ","-",CHR(0)};

VAR  A,B:CARDINAL;

BEGIN
 A:=CharPos(S,"/");
 IF A=MAX(CARDINAL) THEN
  RETURN FALSE;
  END;
 B:=1;
 S2[0]:=CHR(0);
 WHILE NOT (S[A+B] IN Sep) DO
  Append(S2,S[A+B]);
  INC(B);
  END;
 Delete(S,A,B);
 RETURN TRUE;
END GetSwitch;

PROCEDURE Copy117(VAR Ns: ARRAY OF CHAR; S: ARRAY OF CHAR);
VAR
  H,L : CARDINAL;
BEGIN
  H:=HIGH(Ns)+1;
  L := Length(S);
  IF L > H THEN
   L := H
   END;
  Move(ADR(S),ADR(Ns),L);
  IF L < H THEN Ns[L] := CHR(0) END;
END Copy117;

PROCEDURE StripDoubleChar(VAR P1:ARRAY OF CHAR;Ch:CHAR);

VAR N : CARDINAL;

BEGIN
        N:=0;
        LOOP
         IF N>=(Length(P1)-1) THEN
          EXIT
          END;
         IF (P1[N]=Ch) AND (P1[N+1]=Ch) THEN
          Delete(P1,N,1);
          IF N>0 THEN
           DEC(N);
           END;
          END;
         INC(N);
         END;
END StripDoubleChar;

(* Old version before wildcards *)
PROCEDURE FindInPath( File : ARRAY OF CHAR; VAR FullName : ARRAY OF CHAR );
VAR
   ItemA         : CARDINAL;
   Found, NoMore : BOOLEAN;
   DosPath       : ARRAY [0..255] OF CHAR;
BEGIN
   ItemA  := 0;
   Found  := FALSE;
   NoMore := FALSE;
   EnvironmentFind( "PATH", DosPath );
   REPEAT
    Item( FullName, DosPath, CHARSET{';'}, ItemA );
    IF Length( FullName ) = 0 THEN
     NoMore := TRUE;
    ELSE
     IF FIO.Exists(FullName) THEN
      IF FullName[Length(FullName)-1] # '\' THEN
       Append( FullName, '\' );
       END;
     Append( FullName, File );
     Found := FIO.Exists( FullName );
     END;
    END;
    INC( ItemA );
    UNTIL Found OR NoMore;
END FindInPath;

PROCEDURE GetPath(VAR InO:ARRAY OF CHAR;Root : BOOLEAN;Drv:SHORTCARD);

(* Get current Path, if Root=TRUE get path rootdirectory. *)

VAR S : ARRAY[0..1] OF CHAR;

BEGIN
  IF Drv=0 THEN
   Drv:=FIO.GetDrive();
   END;
  IF Root THEN
   InO[0]:=CHR(Drv+64);
   InO[1]:=":";
   InO[2]:="\";
   InO[3]:=CHR(0);
  ELSE
   S[0]:=CHR(Drv+64);
   S[1]:=":";
   FIO.GetDir(Drv,InO);
   Prepend(InO,S);
   END;
END GetPath;

PROCEDURE CDD(S:ARRAY OF CHAR);

VAR A:SHORTCARD;

BEGIN
 IF S[Length(S)-1]="\" THEN
  Delete(S,Length(S)-1,1);
  END;
 IF S[1]=":" THEN                       (* Drive in path? *)
  A:=FIO.SetDrive(SHORTCARD(ORD(S[0])-64));
  Delete(S,0,2);
  END;
 FIO.ChDir(S);
END CDD;


END ModAsm.