MODULE TestBMP;

(* Create some test BMP files. *)

(* V3.0B M. v/d Voort Jul./27/95 - TS 3.1 version (TS 1.17 will probably work
                                    too) qpv can read the binaries generated
                                    by this version.
                                    XTDLIB independant except for GetKey,
                                    a M2-version exists in MODASM
                                    Eliminated module Randomly or so.
   V3.0, J.Andrea, Jan.2/95 -corrected color table use
   V2.0, J.Andrea, Feb.8/94 *)

FROM Lib IMPORT EnableBreakCheck,RANDOM,RANDOMIZE;
FROM IO IMPORT WrLn, WrStr, WrCard, RdStr;
FROM BMP IMPORT BMPFile, Create, Close, WritePixel;
FROM ELib IMPORT GetKey;

VAR
  error         : CARDINAL;
  Bmp           : BMPFile;
  name          : ARRAY [1..80] OF CHAR;
  rows, cols    : CARDINAL;
  Red, Green,
  Blue          : CARDINAL;

  Reds,
  Greens,
  Blues         : ARRAY [1..256] OF CARDINAL;

  i, j, cycle,
  depth,
  answer,
  image_type,
  used_colors,
  imp_colors    : CARDINAL;

BEGIN
  EnableBreakCheck; (*Always easy :-) *)

  WrStr( 'create a test BMP file' ); WrLn;

  WrLn;
  WrStr( 'size of test file' ); WrLn;
  WrStr( '1: 100 by 100 (default)' ); WrLn;
  WrStr( '2: 100 by 255' ); WrLn;
  WrStr( '3: 255 by 255' ); WrLn;
  WrStr( '4: 10 by 10' ); WrLn;
  WrStr( '5: 256 by 256' ); WrLn;
  WrStr( 'choice ? ' ); answer:=GetKey()-48;WrCard(answer,5);  WrLn;
  IF answer = 5 THEN
    rows := 256;  cols := 256;
  ELSIF answer = 2 THEN
    rows := 100;  cols := 255;
  ELSIF answer = 3 THEN
    rows := 255; cols := 255;
  ELSIF answer = 4 THEN
    rows := 10; cols := 10;
  ELSE
    rows := 100; cols := 100;
  END;

  WrLn;
  WrStr( 'type of image to create' ); WrLn;
  WrStr( '1: Blue color wedge (default)' ); WrLn;
  WrStr( '2: Blue and Red color wedge' ); WrLn;
  WrStr( '3: rgb cycle' ); WrLn;
  WrStr( '4: random colors' ); WrLn;
  WrStr( 'choice ? ' ); answer :=GetKey( )-48; WrCard( answer,3 ); WrLn;
  IF ( answer >= 1 ) & ( answer <= 4 ) THEN
    image_type := answer;
  ELSE
    image_type := 1;
  END;

  WrLn;
  WrStr( 'depth of image to create' ); WrLn;
  WrStr( '1:  1 bit per pixel' ); WrLn;
  WrStr( '2:  4 bit per pixel' ); WrLn;
  WrStr( '3:  8 bit per pixel (default)' ); WrLn;
  WrStr( '4: 24 bit per pixel' ); WrLn;
  WrStr( 'choice ? ' ); answer :=GetKey()-48; WrCard( answer,5 ); WrLn;
  IF answer = 1 THEN
    depth := 1;
  ELSIF answer = 2 THEN
    depth := 4;
  ELSIF answer = 4 THEN
    depth := 24;
  ELSE
    depth := 8;
  END;

  (* create the color lookup table, none for the 24 bit image *)
  IF depth = 1 THEN
    (* only allowed to have white and black ? *)
    used_colors := 2;
    (* Blue wedge *)
    Reds[1] :=   0; Greens[1] :=   0; Blues[1] :=   0;
    Reds[2] := 255; Greens[2] := 255; Blues[2] := 255;

  ELSIF depth = 4 THEN
    used_colors := 16;
    IF image_type = 1 THEN
      (* Blue wedge *)
      FOR i := 1 TO used_colors DO
        Reds[i]   := 0;
        Greens[i] := 0;
        Blues[i]  := ( i - 1 ) * ( 256 DIV used_colors );
      END;

    ELSIF image_type = 2 THEN
      (* Blue and Red wedge *)
      Reds[1] := 0; Greens[1] := 0; Blues[1] := 255;
      FOR i := 2 TO used_colors DO
        Reds[i]   := ( i - 1 ) * ( 256 DIV used_colors );
        Greens[i] := 0;
        Blues[i]  := 256 - Reds[i];
      END;

    ELSIF ( image_type = 3 ) OR ( image_type = 4 ) THEN
      (* cycle *)
      (* black for 1 color, then each other 3 has 5 each *)
      FOR i := 1 TO used_colors DO
         Reds[i] := 0; Greens[i] := 0; Blues[i] := 0;
      END;
      FOR i := 1 TO 5 DO
         Reds[i+1]   := ( i - 1 ) * ( 256 DIV 5 );
         Greens[i+6] := ( i - 1 ) * ( 256 DIV 5 );
         Blues[i+11] := ( i - 1 ) * ( 256 DIV 5 );
      END;
    END;

  ELSIF depth = 8 THEN
    used_colors := 256;
    IF image_type = 1 THEN
      (* Blue wedge *)
      FOR i := 1 TO used_colors DO
        Reds[i]   := 0;
        Greens[i] := 0;
        Blues[i]  := ( i - 1 ) * ( 256 DIV used_colors );
      END;

    ELSIF image_type = 2 THEN
      (* Blue and Red wedge *)
      Reds[1] := 0; Greens[1] := 0; Blues[1] := 255;
      FOR i := 2 TO used_colors DO
        Reds[i]   := ( i - 1 ) * ( 256 DIV used_colors );
        Greens[i] := 0;
        Blues[i]  := 256 - Reds[i];
      END;

    ELSIF ( image_type = 3 ) OR ( image_type = 4 ) THEN
      (* cycle *)
      (* black for 1 color, then each other 3 has 85 each *)
      FOR i := 1 TO used_colors DO
         Reds[i] := 0; Greens[i] := 0; Blues[i] := 0;
      END;
      FOR i := 1 TO 85 DO
         Reds[i+1]   := ( i - 1 ) * ( 256 DIV 85 );
         Greens[i+86] := ( i - 1 ) * ( 256 DIV 85 );
         Blues[i+85+86] := ( i - 1 ) * ( 256 DIV 85 );
      END;
    END;

  ELSE
    used_colors := 0;
  END;

  WrLn;
  WrStr( 'name of BMP file to create ? ' ); RdStr( name ); WrLn;

  imp_colors := 0;

  Create( Bmp, name, rows, cols, depth,
          used_colors, imp_colors, Reds, Greens, Blues, error );
  IF error # 0 THEN
    WrStr( "can't create BMP file, error: " ); WrCard( error, 0 );
WrLn;
  ELSE

    Red := 0; Green := 0; Blue := 0;

    cycle := 0;

    FOR i := 1 TO rows DO
      FOR j := 1 TO cols DO

         CASE image_type OF
           1: (* wedge *)
                IF depth = 1 THEN
                  IF i < rows DIV 2 THEN
                    Red := 0;
                  ELSE
                    Red := 1;
                  END;
                ELSE
                  Red := i;
                END;

         | 2: (* double wedge *)
                IF depth = 24 THEN
                  Red := j; Blue := i;
                ELSIF depth = 1 THEN
                  IF i < rows DIV 2 THEN
                    Red := 0;
                  ELSE
                    Red := 1;
                  END;
                ELSE
                  Red := i;
                END;

         | 3: (* cycle *)
                IF depth = 24 THEN
                  IF cycle = 0 THEN
                    Red := 255;  Green :=   0;  Blue :=   0;  cycle := 1;
                  ELSIF cycle = 1 THEN
                    Red :=   0;  Green := 255;  Blue :=   0;  cycle := 2;
                  ELSE
                    Red :=   0;  Green :=   0;  Blue := 255;  cycle := 0;
                  END;
                ELSE
                  IF cycle >= used_colors THEN cycle := 0; END;
                  Red := cycle;
                  INC( cycle );
                END;

         | 4: IF depth = 24 THEN
                  Red   := RANDOM( 256 );
                  Green := RANDOM( 256 );
                  Blue  := RANDOM( 256 );
                ELSE
                  Red := RANDOM( used_colors );
                END;
         END;

         WritePixel( Bmp, Red, Green, Blue );
      END;
    END;

    Close( Bmp );

    WrStr( 'done' ); WrLn;
  END;

END TestBMP.
