IMPLEMENTATION MODULE CCompat;

FROM Lib     IMPORT ParamCount,ParamStr,CommandLine;
FROM ELib    IMPORT AppendBackslash;
FROM Storage IMPORT ALLOCATE,DEALLOCATE;

IMPORT Str;

VAR Active : BOOLEAN;

PROCEDURE InitParam;

VAR A: CARDINAL;

BEGIN
 IF NOT Active THEN
  Active:=TRUE;
  NEW(argv[0]);
  Str.Copy(argv[0]^,CommandLine^);
  IF argc>0 THEN
   FOR A:=1 TO argc DO
    NEW(argv[A]);
    ParamStr(argv[A]^,A);
    END;
   FOR A:= argc+1 TO MaxArg DO
    argv[A]:=NIL;
    END;
   END;
  END;
END InitParam;

PROCEDURE KillParam;

VAR A: CARDINAL;

BEGIN
 IF Active THEN
  Active:=FALSE;
  DISPOSE(argv[0]);
  IF argc>0 THEN
   FOR A:=1 TO argc DO
    DISPOSE(argv[A]);
    argv[A]:=NIL;
    END;
   END;
  END;
END KillParam;

PROCEDURE MakeFilename(Drive,Path,Name,Ext :ARRAY OF CHAR;
                                             VAR ArchiveName : ARRAY OF CHAR);

BEGIN
 ArchiveName[0]:=CHR(0);
 IF Drive[0]#CHR(0) THEN
  Str.Copy(ArchiveName,Drive);
  AppendBackslash(ArchiveName);
  END;
 IF Path[0]#CHR(0) THEN
  Str.Append(ArchiveName,Path);
  AppendBackslash(ArchiveName);
  END;
 Str.Append(ArchiveName,Name);
 IF Ext[0] #"." THEN
  Str.Append(ArchiveName,".");
  END;
  Str.Append(ArchiveName,Ext);
END MakeFilename;

PROCEDURE ParseFilename(fname :ARRAY OF CHAR; VAR Drive,Path,Name,Ext :ARRAY OF CHAR):BOOLEAN;

VAR A,B : CARDINAL;
    Fl : BOOLEAN;

BEGIN
 A:=Str.RCharPos(fname,".");
 IF A = MAX(CARDINAL) THEN
  Ext[0]:=CHR(0);
 ELSE
  Str.Slice(Ext,fname,A+1,Str.Length(fname)-A);
  fname[A]:=CHR(0);
  END;
 Drive[0]:=CHR(0);
 A:=Str.RCharPos(fname,"\");
 B:=Str.CharPos(fname,":");
 IF B=0 THEN RETURN FALSE; END;
 IF A#MAX(CARDINAL) THEN
  IF B=MAX(CARDINAL) THEN
   (* If no ":" exists, path is start string to last \,
   filename is rest *)
   Str.Slice (Path,fname,0,A+1);
   Str.Slice (Name,fname,A+1,Str.Length(fname));
  ELSE
   IF A<B THEN
    RETURN FALSE;
    END;
   Str.Slice (Path,fname,B+1,A-B);
   Str.Slice (Name,fname,A+1,Str.Length(fname));
   END;
  ELSE (*A=MAX(CARDINAL) No backslashes *)
   Path[0]:=CHR(0);
   IF B#MAX(CARDINAL) THEN
    Str.Slice (Name,fname,B+1,Str.Length(fname));
   ELSE
    Str.Copy(Name,fname);
    END;
  END;
 IF (B# MAX(CARDINAL)) THEN
  Drive[0]:=fname[B-1];
  Drive[1]:=CHR(0);
  END;
 RETURN TRUE;
END ParseFilename;


VAR A :CARDINAL;

BEGIN
 argc:=ParamCount();
 FOR A:= 0 TO MaxArg DO
  argv[A]:=NIL;
  END;
 Active:=FALSE;
END CCompat.