MODULE DeHTML;
(* Beginning of a CRTOLF-ish util fit for HTML files,part of the XtdLib
                             package (C) 1998 Marco van de Voort

Right now DEHTML contains 2 routines:

- The default, a very quick 'n dirty DEHTMLer. Creates .TXT from .HTM. Often a
    CrToLf treatment is needed afterwards to remove trash. Written for a
    specific series of HTML files, when I needed it. Not always predictable,
    but reasonable behaviour with normal files. DeHTML is quite agressive, you
    can "tame" it by removing some of the features required for deleting Java
    scripts.

- The second one is very simple, it simply removes all spaces except one between
  each two words (each two not space characters)
  " d         d" becomes "d d". As you can see it also removes leading spaces.
   It's invoked with the /S parameter. *)

IMPORT FIO;
FROM ELib IMPORT ChangeExtension,GetSwitch;
FROM Str IMPORT Match,Caps,Copy;
FROM Lib IMPORT CommandLine;

VAR B1,B2 : ARRAY[0..16383] OF BYTE;

PROCEDURE DeHTMLFile(Name:ARRAY OF CHAR);

VAR FIn,FOut : FIO.File;
    Skip     : BOOLEAN;
    C        : CHAR;
    S        : ARRAY[0..250] OF CHAR;
    InS      : CARDINAL;
    Pre      : BOOLEAN;

BEGIN
 Pre:=TRUE;

 FIn:=FIO.Open(Name);
 ChangeExtension(Name,"TXT");
 FOut:=FIO.Create(Name);
 FIO.AssignBuffer(FIn,B1);
 FIO.AssignBuffer(FOut,B2);
 Skip:=FALSE;
 LOOP
  C:=FIO.RdChar(FIn);
  IF FIO.EOF THEN
   EXIT
   END;
  IF C="<" THEN
   InS:=0;
   C:="f";
   WHILE ((C # ">") AND (InS<150)) AND (C # "<") DO
    C:=FIO.RdChar(FIn);
    S[InS]:=C;
    INC(InS);
    END;

   S[InS-1]:=CHR(0);
   Caps(S);
   IF Match(S,"SCRIPT*") THEN
    Skip:=TRUE;
    END;
   IF Match(S,"/SCRIPT*") THEN
    Skip:=FALSE;
    END;
   IF Match(S,"A NAME*") THEN
    Skip:=TRUE;
    END;
   IF Match(S,"/A*") THEN
    Skip:=FALSE;
    END;
   IF Match(S,"FORM*") THEN
    Skip:=TRUE;
    END;
   IF Match(S,"PRE*") THEN
    Skip:=FALSE;
    END;
   IF Match(S,"/CENTER*") THEN
    Skip:=FALSE;
    END;
   IF Match(S,"/FORM*") THEN
    Skip:=FALSE;
    END;
   
   
   (*
   IF Match(S,"/PRE*") THEN
    Pre:=TRUE;
    Skip:=TRUE;
   ELSE
    IF Pre THEN
     FIO.WrChar(FOut,"<");
     FIO.WrStr(FOut,S);
     END;
    END;
  ELSE   *)
 ELSE
  IF NOT Skip THEN
   FIO.WrChar(FOut,C);
   END;
  END;
  END;
 (* END; *)
 FIO.Close(FOut);
 FIO.Close(FIn);
END DeHTMLFile;

PROCEDURE KillSpaces(S:ARRAY OF CHAR);

CONST Tester="tmp.tmp";

VAR S2     : ARRAY[0..100] OF CHAR;
    B1,B2 : ARRAY[0..4095] OF CHAR;
    F,F2  : FIO.File;
    C,C2  : CHAR;

BEGIN
  IF FIO.Exists(S) THEN
   F:=FIO.Open(S);
   F2:=FIO.Create(Tester);
   FIO.AssignBuffer(F,B1);
   FIO.AssignBuffer(F2,B2);
   C2:="";
   LOOP
    C:=FIO.RdChar(F);
    IF FIO.EOF THEN
     EXIT
     END;
    IF C=CHR(32) THEN
     IF ((C2#CHR(32)) AND (C2#CHR(13))) AND (C2#CHR(10)) THEN
       FIO.WrChar(F2,C);
       END;
     ELSE
       FIO.WrChar(F2,C);
      END;
     C2:=C;
     END;
    FIO.Close(F);FIO.Close(F2);
    Copy(S2,S);
    ChangeExtension(S2,"bak");
    IF FIO.Exists(S2) THEN
     FIO.Erase(S2);
     END;
    FIO.Rename (S,S2);
    FIO.Rename (Tester,S);
  END;
END KillSpaces;

VAR D : FIO.DirEntry;
    S,S2 : ARRAY[0..127] OF CHAR;
    Spaces : BOOLEAN;

BEGIN
 Spaces:=FALSE;
 Copy(S,CommandLine^);
 Caps(CommandLine^);
 WHILE GetSwitch(S,S2,"/") DO
  CASE S2[0] OF
   | "S" : Spaces:=TRUE;
   END;
  END;

 IF FIO.ReadFirstEntry("*.HTM",FIO.FileAttr{},D) THEN
  REPEAT
   IF Spaces THEN
    KillSpaces(D.Name);
   ELSE
    DeHTMLFile(D.Name);
    END;
  UNTIL NOT FIO.ReadNextEntry(D);
  END;
END DeHTML.
