MODULE DemoFont;
(* Demo belonging to CoreFont(XtdLib package), (C) by Marco van de Voort 1996
   VGA/EGA only!!

Requires Borland .CHR fonts, which are not included because of copyright
reasons. The names of the fonts required are stored in Names. These are
the standard fonts included with Borland(or Turbo-) Pascal 7.0.

Because the ChrLib Module is all-M2, and moreover entirely floating-point,
a DX2-66 and compilation without copro-emulation would be nice.

*)

FROM ELib IMPORT GetKey;
FROM Graph IMPORT InitGraph,GraphMode,TextMode,SetVideoMode,InitVGA;
FROM ChrLib IMPORT DrawChar,ChrRec,Tabels,Data,LoadCHR,DrawStr,GrGotoXY,
                   DeAllocFont,SetColor,Color,SetOrientation;
FROM MATHLIB IMPORT Cos,Sin;

TYPE StrType=ARRAY[0..9] OF CHAR;
     StrArr =ARRAY[0..9] OF StrType;
     FactArr=ARRAY[0..9] OF REAL;

CONST

 Names  = StrArr("EURO.CHR","GOTH.CHR","LCOM.CHR","LITT.CHR","SANS.CHR",
                  "SCRI.CHR","SIMP.CHR","TRIP.CHR","TSCR.CHR","BOLD.CHR");
 Fact  = FactArr( 0.5 , 1.0, 1.0, 3.0, 1.0, 1.0, 1.0, 1.0, 1.0 ,0.5);


PROCEDURE ShowFonts1;

VAR R: ARRAY[0..9] OF ChrRec;
    A,B,C,D,E:CARDINAL;

BEGIN
 FOR D:=0 TO 9 DO
   GraphMode;
   LoadCHR(Names[D],R[D]);
   C:=0;
   B:=0;
   FOR A:=0 TO R[D].ChInFont-1 DO
    GrGotoXY(C,B);
    DrawChar(A+R[D].FirstAsc,R[D],Fact[D]);
    INC(C,10+INTEGER(Fact[D]* REAL(R[D].TP^[R[D].ChInFont*2-2+A])));
    IF (C+10+CARDINAL(Fact[D]* REAL(R[D].TP^[R[D].ChInFont*2-2+A+1])))>639 THEN
     C:=0;
     INC (B,CARDINAL(REAL(R[D].TopD)*Fact[D])+10);
     END;
    END;
  DeAllocFont(R[D]);
  A:=GetKey();
  END;
END ShowFonts1;

PROCEDURE ShowFonts2;

VAR  R          : ChrRec;
     A,B        : CARDINAL;

BEGIN
 GraphMode;
 B:=0;
 FOR A:=0 TO 9 DO
  LoadCHR(Names[A],R);
  GrGotoXY(0,B);
  DrawStr("The Quick Brown Fox Jumps",R,Fact[A]);
  DeAllocFont(R);
  INC(B,INTEGER(REAL(R.TopD)*Fact[A])+10);
  END;
 A:=GetKey();
END ShowFonts2;

PROCEDURE ScaleDemo;

VAR  R          : ChrRec;
     A          : CARDINAL;

BEGIN
 LoadCHR("Goth.chr",R);
 GraphMode;
 DrawStr("Hello Peter",R,1.0);
 GrGotoXY(0,30);
 DrawStr("Hello Peter",R,2.0);
 GrGotoXY(0,90);
 DrawStr("Hello Peter",R,3.0);
 GrGotoXY(0,320);
 DrawStr("Press a key to continue",R,0.5);
 A:=GetKey();
 GraphMode;
 GrGotoXY(0,0);
 FOR A:=0 TO 7 DO
  DrawChar(64+A,R,REAL(A));
  END;
 GrGotoXY(0,160);
  FOR A:=0 TO 7 DO
  DrawChar(71+A,R,REAL(A));
  END;
 GrGotoXY(0,320);
 FOR A:=0 TO 7 DO
  DrawChar(78+A,R,REAL(A));
  END;
 A:=GetKey();
 DeAllocFont(R);
END ScaleDemo;

PROCEDURE Circle;

TYPE Tabel=ARRAY[0..9] OF REAL;

CONST CosTab=Tabel(1.000, 0.9848, 0.9396, 0.8666, 0.7660, 0.6427, 0.5000,
                   0.342, 0.1736, 0.0000);

     (* Sintab= Costab[9-angle] *)
      DegToRad=3.141592654/180.0;

VAR R:ChrRec;
    A:CARDINAL;

BEGIN
 IF NOT SetVideoMode(18) THEN
  HALT
  END;
 LoadCHR("Litt.CHR",R);
 FOR A:=0 TO 35 DO
  IF A MOD 16=0 THEN
   SetColor(Color(9));
  ELSE
   SetColor(Color(A));

   END;
  SetOrientation(REAL(Cos(LONGREAL(A)*10.0*DegToRad)),REAL(Sin(LONGREAL(A)*10.0*DegToRad)));
  GrGotoXY(320,240);
  DrawStr("The Quick Brown Fox Jumps",R,1.5);
  END;
 DeAllocFont(R);
 A:=GetKey();
 GraphMode;
 LoadCHR("GOTH.CHR",R);
 GrGotoXY(10,10);
 SetOrientation(CosTab[1],CosTab[8]);
 DrawStr("Hello World,how is it?",R,1.5);
 A:=GetKey();
 DeAllocFont(R);
 SetOrientation(1.0,0.0);
END Circle;

BEGIN
 InitGraph;
 GraphMode;
 IF NOT SetVideoMode(18) THEN
  HALT
  END;
 ScaleDemo;
 ShowFonts1;
 Circle;
 ShowFonts2;
 TextMode;
END DemoFont.
