MODULE ObjView;
(* Skeleton for playing with .OBJ files of TS 3.1. Based on BINFILE.DOC.
             ,XtdLib package (C) by Marco van de Voort 1997

I had some problems with TASM .OBJs in the environment (complicated ones,
 with exported variables, procedures etc, everything which can exist in a
 normal module, calling other modules' procedures) and decided to take a look
 in an .OBJ.

 Right now only the labels I was interested in are processed, see BINFILE.DOC
 for expansions

    *)

IMPORT FIO,IO;
FROM Lib IMPORT ParamCount,ParamStr;

TYPE Str=  ARRAY[0..200] OF CHAR;

CONST Usage="ObjView 0.0001, peep into a TopSpeed OBJ file." +CHR(13)+CHR(10)+
            "Usage : ObjView [objfile]   e.g. ObjView REST\OBJVIEW.OBJ"+CHR(13)
            +CHR(10);

PROCEDURE GetInd(F:FIO.File):CARDINAL;

VAR Tmp : CARDINAL;

BEGIN
    Tmp := CARDINAL( FIO.RdChar(F) );
    IF Tmp < 128 THEN
      RETURN Tmp;
    ELSE
      RETURN ( Tmp - 128 )<<8 + CARDINAL( FIO.RdChar(F));
    END;
END GetInd;

PROCEDURE Get16(F:FIO.File):CARDINAL;

BEGIN
   RETURN  CARDINAL( FIO.RdChar(F) ) + CARDINAL( FIO.RdChar(F))<<8;
END Get16;

VAR F           : FIO.File;
    Tag         : BYTE;
    Len,
    Len2,
    Attr,
    SegLen,
    Tmp         : CARDINAL;
    Data        : ARRAY[0..4095] OF BYTE;
    S           : ARRAY[0..99] OF CHAR;

BEGIN
 IF ParamCount()=0 THEN
  IO.WrStr(Usage);
  HALT;
  END;
 ParamStr(S,1);
 IF NOT FIO.Exists(S) THEN
  IO.WrStr(Usage);
  HALT;
  END;
 F:=FIO.Open(S);
 Tag:=FIO.RdChar(F);
 IF Tag # BYTE(080H) THEN
  IO.WrStr("Invalid .OBJ type");
  HALT;
  END;
 LOOP
  CASE Tag OF
   | BYTE(080H) : Len:=Get16(F);
                  Len2:=CARDINAL(FIO.RdChar(F));
                  Tmp:=FIO.RdBin(F,Data,Len2);
                  Data[Len2]:=0;
                  IO.WrStr(Str(Data)); IO.WrLn;
                  Tmp:=CARDINAL(FIO.RdChar(F)); (* Crc *)
   | BYTE(098H):  Len:=Get16(F);
                  Attr:=CARDINAL(FIO.RdChar(F));
                  IO.WrHex(Attr,-5);
                  SegLen:=Get16(F);
                  IO.WrCard(SegLen,-6);
                  IO.WrStr("NameIndices : ");
                  IO.WrCard(GetInd(F),5);
                  IO.WrCard(GetInd(F),5);
                  IO.WrCard(GetInd(F),5);
                  IO.WrLn;
                  Tmp:=CARDINAL(FIO.RdChar(F)); (* Crc *)
   | BYTE(08AH) : EXIT
   | BYTE(096H) : Len:=Get16(F);
                  Len2:=CARDINAL(FIO.RdChar(F));
                  DEC (Len);
                  Tmp:=FIO.RdBin(F,Data,Len2);
                  DEC(Len,Tmp);
                  Data[Len2]:=0;
                  IO.WrStr("*");
                  IO.WrStr(Str(Data)); IO.WrLn;
                  IF Len>1 THEN
                   Tmp:=FIO.RdBin(F,Data,Len-1);
                   END;
                  Tmp:=CARDINAL(FIO.RdChar(F)); (* Crc *)
  ELSE
   Len:=Get16(F);
   Tmp:=FIO.RdBin(F,Data,Len);
   END;
  Tag:=FIO.RdChar(F);
  END;
 FIO.Close(F);


END ObjView.