MODULE PullDemo;
(* Main PullDown Demo, XtdLib package, (C) by Marco van de Voort 1997

This should become *THE* demostration of module PullDown, iow all Window
interfacing.

MENU.SRC belongs to this demo! Menu.DEF not necessarily, since it
can be generated out of MENU.SRC! .SRC files reside in directory source.
Please note that Menu.SRC was changed some versions ago, please
recompile to make sure you have a recent version.

This module looks huge, but so is the pulldown menu. You can at least half
it by not using the select and helpfunctions. Simply replace the two last
procedurenames in the PullDef definitions with NULLPROC, and delete the
corresponding procedures. The double tric (both SubMenu AND Pulldown) is
already doubling this source.
*)

FROM Window   IMPORT WinType,Color;
FROM Menu     IMPORT PullA,FirstSub;
FROM PullDown IMPORT PullOpen,PullHandle,GetPullKey,PullClose,PullDef,ColT,Style3,
                     PullObject,OnOffItem,StType,GetObjAddr;
FROM Lib IMPORT EnableBreakCheck;
FROM ELib IMPORT GetKey;
FROM Str IMPORT Length,CharPos;

IMPORT IO,Menu,Window,PullDown;

(* Two types (actually one, StrArr is not used separately),
    needed for accessing textual constants without copying   *)

TYPE    StrArr  = ARRAY[0..400] OF CHAR;
        StrPoint= POINTER TO StrArr;

CONST WrLn=CHR(13)+CHR(10); (* To ease definition, not used separately*)

      (* Some helptexts, with linefeeds integrated. You must format (align
         and wrap) them yourself, but that's a limitation of a PullDemo
         procedure, not PullDown itself, a real wrapper is build into
         WordW.MOD *)

      HidePullHelp   = WrLn+ "This item hides the pulldownmenu,"+ WrLn+
                   "waits for a key, and PullDown continues."+ WrLn+
                   "Unhiding is automagical.";
      SubHelp        = WrLn+ "This item opens a submenu, independant" +WrLn+
                    "of the pulldownmenu. See SubDemo for " +WrLn+
                    "another example of submenus.";
      SaveHelp      = WrLn + "If you press enter on this option, " +WrLn+
                     "saving will be turned on or off.";
      SwapHelp      = WrLn + "Setup the desired type of swapping"+ WrLn+
                     " to XMS or EMS memory, or to disk";

       (* Statusline on the bottom of the screen *)
      StatusLine="Esc=Exit  F1=Context-sensitive help";

(*
PROCEDURE GetKey():CARDINAL;

VAR GA : CARDINAL;
    Fl : BOOLEAN;
BEGIN
 LOOP
  IF KeyPressed() THEN
   GA:=ORD(RdKey());
   EXIT
   END;
  END;
  IF GA=0 THEN
   GA:=ORD(RdKey())<<8;
   END;
 RETURN GA;
END GetKey;*)

PROCEDURE Swapping(H:PullHandle;Label:CARDINAL);
(* On/Off like procedure, options swapping to XMS,EMS and Disk
   Label is a field with in the last 4 bytes "XMS ","EMS " or "DISK"
   (case insensitive)
  Not as safe as On/Off, but quite safe.
  I.o.w. the procedure is safe. The way it's programmed not. Pointers to
  mem locations etc.
  It's done mere as an example, because PullDown.OnOffItem is programmed
  VERY strict.
  *)

TYPE St2T=ARRAY[0..3] OF CHAR; (* If I use StType for this, I get trouble*)
     St2P=POINTER TO St2T;     (* with the CHR(0) *)

VAR St : StType;
    St2: St2P;
    A : CARDINAL;

BEGIN
 St:=GetObjAddr(H,Label,A);      (* Get pointer to string belonging to Label*)
 A:=CharPos(St^,"'")-4;          (* Calculate Length(String)-4 ("XMS ")*)
 IF A >65000 THEN RETURN END; (* Safety... *)
 St2:=ADR(St^[A]);               (* Pointer to Str[4] to last 4 chars*)
 CASE CAP(St2^[0]) OF            (* 1st character a ?, if some first characters
                                    are the same, add checks*)
  | "X" : St2^:="EMS ";
  | "E" : St2^:="Disk";
  | "D" : St2^:="XMS ";
  END;
END Swapping;

PROCEDURE WrLab(S:ARRAY OF CHAR);
(* Rough procedure, writes the S on a certain spot to the screen*)

BEGIN
 Window.Use (Window.FullScreen);
 Window.GotoXY(40,20);
 Window.TextColor(LightGray);
 IO.WrCharRep(CHR(177),40);
 Window.GotoXY(40,20);
 Window.TextColor(Magenta);
 IO.WrStr("Last picked label : ");
 Window.TextColor(Green);
 IO.WrStr(S);
END WrLab;

(* Window definition for an helpwindow*)
CONST HelpDef=Window.WinDef(20,4,65,8,White,Black,FALSE,TRUE,FALSE,TRUE,
                            Window.DoubleFrame,Yellow,Black);

PROCEDURE WrHelp(S:ARRAY OF CHAR);
(* Create a small helpwindow and put the argument text in it *)

VAR L : WinType;
    A : CARDINAL;

BEGIN
 L:=Window.Open(HelpDef);
 Window.Use (L);
 IO.WrLn;
 IO.WrStr("This is the help for : ");
 IO.WrStr(S);
 A:=GetKey();
 Window.Close(L);
END WrHelp;

PROCEDURE OtherHelp(Pnt : StrPoint);
(* A little bit more advanced procedure, writes several lines of help,
   Very limited, is only 5 lines :-) *)

VAR L : WinType;
    A : CARDINAL;

BEGIN
 L:=Window.Open(HelpDef);
 Window.Use (L);
 IO.WrStr(Pnt^);
 A:=GetKey();
 Window.Close(L);
END OtherHelp;

PROCEDURE WrSubSelect(S:ARRAY OF CHAR);
(* Writes the select text S to the screen, for submenus*)

BEGIN
 Window.CursorOff;
 Window.GotoXY(10,23); Window.TextColor(Window.Blue); IO.WrCharRep("",50);
 Window.GotoXY(10,23); Window.TextColor(Red);
 IO.WrStr("SubMenu:"); Window.TextColor(Yellow);      IO.WrStr(S);
END WrSubSelect;

PROCEDURE WrSelect(S:ARRAY OF CHAR);
(* PullDown version of write select test*)

BEGIN
 Window.CursorOff;
 Window.GotoXY(10,23); Window.TextColor(Window.Blue); IO.WrCharRep("",50);
 Window.GotoXY(10,23); Window.TextColor(Yellow);      IO.WrStr(S);
END WrSelect;

PROCEDURE SubMenu(InCode,H:CARDINAL):CARDINAL;
(* Called when an item in a submenu is selected, outputs a short name
    with WrLab.*)

VAR A : CARDINAL;

BEGIN
   CASE InCode OF
   | MAX(CARDINAL)  : RETURN 0;
   | Menu.Beer             :      WrLab("Beer");
   | Menu.VinRose          :      WrLab("VinRose");
   | Menu.R_Bordeaux       :      WrLab("R_Bordeaux");
   | Menu.CotesRhone       :      WrLab("CotesRhone");
   | Menu.VinDPRed         :      WrLab("VinDPRed");
   | Menu.W_Bordeaux       :      WrLab("W_Bordeaux");
   | Menu.Moezel2          :      WrLab("Moezel2");
   | Menu.VinDPWhite       :      WrLab("VinDPWhite");
   | Menu.Champi           :      WrLab("Champi");
   | Menu.Zekt2            :      WrLab("Zekt2");
   | Menu.Whisky           :      WrLab("Whisky");
   | Menu.JongeK           :      WrLab("JongeK");
   | Menu.Vodka            :      WrLab("Vodka");
   | Menu.Aper1            :      WrLab("Aper1");
   | Menu.Aper2            :      WrLab("Aper2");
   | Menu.Aper3            :      WrLab("Aper3");
   END;
RETURN 0 ;
END SubMenu;

PROCEDURE SubMenuSelect(InCode,H:CARDINAL):CARDINAL;
(* Called whenever the cursor moves over a selectable identifier,
writes some text to the screen, Submenu version*)

BEGIN
 Window.Use(Window.FullScreen);
    CASE InCode OF
   | MAX(CARDINAL)  : RETURN 0;
   | Menu.Beer             :      WrSubSelect("Beer");
   | Menu.VinRose          :      WrSubSelect("VinRose");
   | Menu.R_Bordeaux       :      WrSubSelect("R_Bordeaux");
   | Menu.CotesRhone       :      WrSubSelect("CotesRhone");
   | Menu.VinDPRed         :      WrSubSelect("VinDPRed");
   | Menu.W_Bordeaux       :      WrSubSelect("W_Bordeaux");
   | Menu.Moezel2          :      WrSubSelect("Moezel2");
   | Menu.VinDPWhite       :      WrSubSelect("VinDPWhite");
   | Menu.Champi           :      WrSubSelect("Champi");
   | Menu.Zekt2            :      WrSubSelect("Zekt2");
   | Menu.Whisky           :      WrSubSelect("Whisky");
   | Menu.JongeK           :      WrSubSelect("JongeK");
   | Menu.Vodka            :      WrSubSelect("Vodka");
   | Menu.Aper1            :      WrSubSelect("Aper1");
   | Menu.Aper2            :      WrSubSelect("Aper2");
   | Menu.Aper3            :      WrSubSelect("Aper3");
   END;
RETURN 0 ;
END SubMenuSelect;

PROCEDURE SubMenuHelp(InCode,H:CARDINAL):CARDINAL;
(* Helpfunction for SubMenu, whenever help (F1) is pressed
 on a selectable item, an helptext is displayed*)

BEGIN
   CASE InCode OF
   | MAX(CARDINAL)  : RETURN 0;
   | Menu.Beer             :      WrHelp("Beer");
   | Menu.VinRose          :      WrHelp("VinRose");
   | Menu.R_Bordeaux       :      WrHelp("R_Bordeaux");
   | Menu.CotesRhone       :      WrHelp("CotesRhone");
   | Menu.VinDPRed         :      WrHelp("VinDPRed");
   | Menu.W_Bordeaux       :      WrHelp("W_Bordeaux");
   | Menu.Moezel2          :      WrHelp("Moezel2");
   | Menu.VinDPWhite       :      WrHelp("VinDPWhite");
   | Menu.Champi           :      WrHelp("Champi");
   | Menu.Zekt2            :      WrHelp("Zekt2");
   | Menu.Whisky           :      WrHelp("Whisky");
   | Menu.JongeK           :      WrHelp("JongeK");
   | Menu.Vodka            :      WrHelp("Vodka");
   | Menu.Aper1            :      WrHelp("Aper1");
   | Menu.Aper2            :      WrHelp("Aper2");
   | Menu.Aper3            :      WrHelp("Aper3");
   END;
RETURN 0 ;
END SubMenuHelp;

(*
                    KeyCol,             (* Color of predefined keys*)
                    Text,               (* Color of normal text (in menu) *)
                    InCol,              (* Background color menu when not lit*)
                    HiCol,              (* textcolor menu when lit*)
                    HiBack,             (* background color menu when lit*)
                    Rand,               (* Color of menu's border*)
                    RandBack,           (* Background color of menu's border.*)
                    TextTop,            (* Color of Top when not lit *)
                    Top,                (* Background of Top when not lit *)
                    HiTop,              (* Textcolor of Top when lit *)
                    HiBTop : Color;     (* Background of Top when lit*)*)

(* Pulldefinition for submenu ( style, colors and procedures, positions and
                     some booleans are pulldown menus only, and ignored)*)
CONST SubDef=PullDef(ColT(LightMagenta,LightGray,DarkGray,White,LightGreen,
                   Yellow,LightGray,Blue,LightRed,LightBlue,DarkGray,Style3)
                   ,TRUE,22,SubMenu,SubMenuHelp,SubMenuSelect);

PROCEDURE SubDemo;
(* The actual displaying of the submenu, called from DoPull. *)

VAR
    H   : PullHandle;
    I   : CARDINAL;

BEGIN
 (* PullOpen is used, but FirstSub is a SubMenu object, see Menu.DEF!
    In the definition of FirstSub, some of the fields are NIL to indicate
     a SubMenu. *)
 H:=PullOpen(PullObject(FirstSub),SubDef); (* textual, colors and procedure
                                              data transfer to PullDown,
                                               sets up handle*)

 I:=PullDown.SubKey(H,60,5);               (* SubMenu on coordinates (60,5)*)
 PullClose(H);                             (* Close SubMenu, release memory.*)
END SubDemo;

PROCEDURE DoPull(InCode,H:CARDINAL):CARDINAL;
(* Called when a pulldown menu item is selected *)

VAR A : CARDINAL;

BEGIN
   CASE InCode OF
   | MAX(CARDINAL)  : RETURN 0;
   |   Menu.alch_BMP     :    WrLab ("alch_BMP");
   |   Menu.alch_Gif     :    WrLab ("alch_Gif");
   |   Menu.alch_Hand    :    WrLab ("alch_Hand");
   |   Menu.alch_JPG     :    WrLab ("alch_JPG");
   |   Menu.ArchARJ      :    WrLab ("ArchARJ");
   |   Menu.ArchLZH      :    WrLab ("ArchLZH");
   |   Menu.Hide         :    PullDown.PullHide(H);
                              WrLab ("Menu- Hidden");
                              OtherHelp(ADR(HidePullHelp));
   |   Menu.ArchPAQ      :    WrLab ("ArchPAQ");
   |   Menu.ArchRAR      :    WrLab ("ArchRAR");
   |   Menu.ArchUC2      :    WrLab ("ArchUC2");
   |   Menu.ArchZIP      :    WrLab ("ArchZIP");
   |   Menu.BC4          :    WrLab ("BC4");
   |   Menu.BmpTarga     :    WrLab ("BmpTarga");
   |   Menu.Bordeaux     :    WrLab ("Bordeaux");
   |   Menu.Bourgogne    :    WrLab ("Bourgogne");
   |   Menu.BP7          :    WrLab ("BP7");
   |   Menu.Champagne    :    WrLab ("Champagne");
   |   Menu.Chem1        :    WrLab ("Chem1");
   |   Menu.Chem2        :    WrLab ("Chem2");
   |   Menu.Chem3        :    WrLab ("Chem3");
   |   Menu.Copy         :    WrLab ("Copy");
   |   Menu.Cut          :    WrLab ("Cut");
   |   Menu.Delete       :    WrLab ("Delete");
   |   Menu.DosShell     :    WrLab ("DosShell");
   |   Menu.EndProgram   :    WrLab ("EndProgram");
   |   Menu.Epsilon      :    WrLab ("Epsilon");
   |   Menu.Excel        :    WrLab ("Excel");
   |   Menu.Exit         :    WrLab ("Exit");
   |   Menu.GifJpg       :    WrLab ("GifJpg");
   |   Menu.GNU          :    WrLab ("GNU");
   |   Menu.Help_Ind     :    WrLab ("Help_Ind");
   |   Menu.Help_Instal  :    WrLab ("Help_Instal");
   |   Menu.Help_Rebuild :    WrLab ("Help_Rebuild");
   |   Menu.Help_Search  :    WrLab ("Help_Search");
   |   Menu.Help_Topics  :    WrLab ("Help_Topics");
   |   Menu.Help_Tutorial:    WrLab ("Help_Tutorial");
   |   Menu.HIO1         :    WrLab ("HIO1");
   |   Menu.HIO2         :    WrLab ("HIO2");
   |   Menu.ImportClip   :    WrLab ("ImportClip");
   |   Menu.Insert       :    WrLab ("Insert");
   |   Menu.JpgBmp       :    WrLab ("JpgBmp");
   |   Menu.Lite         :    WrLab ("Lite");
   |   Menu.Load         :    WrLab ("Load");
   |   Menu.LoadBlk      :    WrLab ("LoadBlk");
   |   Menu.Lotus22      :    WrLab ("Lotus22");
   |   Menu.Lotus31      :    WrLab ("Lotus31");
   |   Menu.Make         :    WrLab ("Make");
   |   Menu.Moezel       :    WrLab ("Moezel");
   |   Menu.NewBatToExe  :    WrLab ("NewBatToExe");
   |   Menu.NewCom       :    WrLab ("NewCom");
   |   Menu.NewDeskTop   :    WrLab ("NewDeskTop");
   |   Menu.NewExe       :    WrLab ("NewExe");
   |   Menu.NewObj       :    WrLab ("NewObj");
   |   Menu.NewPklite    :    WrLab ("NewPklite");
   |   Menu.NewSource    :    WrLab ("NewSource");
   |   Menu.NulModem     :    WrLab ("NulModem");
   |   Menu.Paste        :    WrLab ("Paste");
   |   Menu.QPro         :    WrLab ("QPro");
   |   Menu.Quit         :    WrLab ("Quit");
   |   Menu.RedWine      :    WrLab ("RedWine");
   |   Menu.Return       :    WrLab ("Return");
   |   Menu.Save         :    WrLab ("Save");
   |   Menu.SaveBlk      :    WrLab ("SaveBlk");
   |   Menu.SaveOnlyMain :    WrLab ("SaveOnlyMain");
   |   Menu.Snail        :    WrLab ("Snail");
   |   Menu.Sort         :    WrLab ("Sort");
   |   Menu.StayResd     :    WrLab ("StayResd");
   |   Menu.Terra        :    WrLab ("Terra");
   |   Menu.TeX          :    WrLab ("TeX");
   |   Menu.Toad         :    WrLab ("Toad");
   |   Menu.TS117        :    WrLab ("TS117");
   |   Menu.TS31         :    WrLab ("TS31");
   |   Menu.Turtle       :    WrLab ("Turtle");
   |   Menu.VinPays      :    WrLab ("VinPays");
   |   Menu.Word60       :    WrLab ("Word60");
   |   Menu.WP51         :    WrLab ("WP51");
   |   Menu.WP60         :    WrLab ("WP60");
   |   Menu.WP61Win      :    WrLab ("WP61Win");
   |   Menu.WP62Win      :    WrLab ("WP62Win");
   |   Menu.Zekt         :    WrLab ("Zekt");
   |   Menu.SaveConfig   :    OnOffItem(H,Menu.SaveConfig);
                              RETURN 1;
   |   Menu.SaveConf2    :    OnOffItem(H,Menu.SaveConf2);
                              RETURN 1;

   |   Menu.SubMenu      :    SubDemo;
   |   Menu.Swapping     :    Swapping(H,Menu.Swapping);
                              RETURN 1;
   END;
RETURN 0 ;
END DoPull;

PROCEDURE Select(InCode,H:CARDINAL):CARDINAL;
(* Called when you move over a selectable item. pulldown menu version *)

BEGIN
 Window.Use(Window.FullScreen);
    CASE InCode OF
   | MAX(CARDINAL)  : RETURN 0;
   |   Menu.NewFile      :    WrSelect ("Menu:NewFile");
   |   Menu.Con_Serv     :    WrSelect ("Menu:Con_Serv");
   |   Menu.Chemnet      :    WrSelect ("Menu:Chemnet");
   |   Menu.SpreadSheet  :    WrSelect ("Menu:SpreadSheet");
   |   Menu.TopSpeed     :    WrSelect ("Menu:TopSpeed");
   |   Menu.ExeFile      :    WrSelect ("Menu:ExeFile");
   |   Menu.WWine        :    WrSelect ("Menu:WWine");
   |   Menu.WordProc     :    WrSelect ("Menu:WordProc");
   |   Menu.WordPerf     :    WrSelect ("Menu:WordPerf");
   |   Menu.Borland      :    WrSelect ("Menu:Borland");
   |   Menu.Archive      :    WrSelect ("Menu:Archive");
   |   Menu.Communicat   :    WrSelect ("Menu:Communicat");
   |   Menu.Stack        :    WrSelect ("Menu:Stack");
   |   Menu.ImageAl      :    WrSelect ("Menu:ImageAl");
   |   Menu.Programming  :    WrSelect ("Menu:Programming");
   |   Menu.alch_BMP     :    WrSelect ("alch_BMP");
   |   Menu.alch_Gif     :    WrSelect ("alch_Gif");
   |   Menu.alch_Hand    :    WrSelect ("alch_Hand");
   |   Menu.alch_JPG     :    WrSelect ("alch_JPG");
   |   Menu.ArchARJ      :    WrSelect ("ArchARJ");
   |   Menu.ArchLZH      :    WrSelect ("ArchLZH");
   |   Menu.ArchPAQ      :    WrSelect ("ArchPAQ");
   |   Menu.ArchRAR      :    WrSelect ("ArchRAR");
   |   Menu.ArchUC2      :    WrSelect ("ArchUC2");
   |   Menu.ArchZIP      :    WrSelect ("ArchZIP");
   |   Menu.BC4          :    WrSelect ("BC4");
   |   Menu.BmpTarga     :    WrSelect ("BmpTarga");
   |   Menu.Bordeaux     :    WrSelect ("Bordeaux");
   |   Menu.Bourgogne    :    WrSelect ("Bourgogne");
   |   Menu.BP7          :    WrSelect ("BP7");
   |   Menu.Champagne    :    WrSelect ("Champagne");
   |   Menu.Chem1        :    WrSelect ("Chem1");
   |   Menu.Chem2        :    WrSelect ("Chem2");
   |   Menu.Chem3        :    WrSelect ("Chem3");
   |   Menu.Copy         :    WrSelect ("Copy");
   |   Menu.Cut          :    WrSelect ("Cut");
   |   Menu.Delete       :    WrSelect ("Delete");
   |   Menu.DosShell     :    WrSelect ("DosShell");
   |   Menu.EndProgram   :    WrSelect ("EndProgram");
   |   Menu.Epsilon      :    WrSelect ("Epsilon");
   |   Menu.Excel        :    WrSelect ("Excel");
   |   Menu.Exit         :    WrSelect ("Exit");
   |   Menu.GifJpg       :    WrSelect ("GifJpg");
   |   Menu.GNU          :    WrSelect ("GNU");
   |   Menu.Help_Ind     :    WrSelect ("Help_Ind");
   |   Menu.Help_Instal  :    WrSelect ("Help_Instal");
   |   Menu.Help_Rebuild :    WrSelect ("Help_Rebuild");
   |   Menu.Help_Search  :    WrSelect ("Help_Search");
   |   Menu.Help_Topics  :    WrSelect ("Help_Topics");
   |   Menu.Help_Tutorial:    WrSelect ("Help_Tutorial");
   |   Menu.HIO1         :    WrSelect ("HIO1");
   |   Menu.HIO2         :    WrSelect ("HIO2");
   |   Menu.ImportClip   :    WrSelect ("ImportClip");
   |   Menu.Insert       :    WrSelect ("Insert");
   |   Menu.JpgBmp       :    WrSelect ("JpgBmp");
   |   Menu.Lite         :    WrSelect ("Lite");
   |   Menu.Load         :    WrSelect ("Load");
   |   Menu.LoadBlk      :    WrSelect ("LoadBlk");
   |   Menu.Lotus22      :    WrSelect ("Lotus22");
   |   Menu.Lotus31      :    WrSelect ("Lotus31");
   |   Menu.Make         :    WrSelect ("Make");
   |   Menu.Moezel       :    WrSelect ("Moezel");
   |   Menu.NewBatToExe  :    WrSelect ("NewBatToExe");
   |   Menu.NewCom       :    WrSelect ("NewCom");
   |   Menu.NewDeskTop   :    WrSelect ("NewDeskTop");
   |   Menu.NewExe       :    WrSelect ("NewExe");
   |   Menu.NewObj       :    WrSelect ("NewObj");
   |   Menu.NewPklite    :    WrSelect ("NewPklite");
   |   Menu.NewSource    :    WrSelect ("NewSource");
   |   Menu.NulModem     :    WrSelect ("NulModem");
   |   Menu.Paste        :    WrSelect ("Paste");
   |   Menu.QPro         :    WrSelect ("QPro");
   |   Menu.Quit         :    WrSelect ("Quit");
   |   Menu.RedWine      :    WrSelect ("RedWine");
   |   Menu.Return       :    WrSelect ("Return");
   |   Menu.Save         :    WrSelect ("Save");
   |   Menu.SaveBlk      :    WrSelect ("SaveBlk");
   |   Menu.SaveOnlyMain :    WrSelect ("SaveOnlyMain");
   |   Menu.Snail        :    WrSelect ("Snail");
   |   Menu.Sort         :    WrSelect ("Sort");
   |   Menu.StayResd     :    WrSelect ("StayResd");
   |   Menu.Terra        :    WrSelect ("Terra");
   |   Menu.TeX          :    WrSelect ("TeX");
   |   Menu.Toad         :    WrSelect ("Toad");
   |   Menu.TS117        :    WrSelect ("TS117");
   |   Menu.TS31         :    WrSelect ("TS31");
   |   Menu.Turtle       :    WrSelect ("Turtle");
   |   Menu.VinPays      :    WrSelect ("VinPays");
   |   Menu.Word60       :    WrSelect ("Word60");
   |   Menu.WP51         :    WrSelect ("WP51");
   |   Menu.WP60         :    WrSelect ("WP60");
   |   Menu.WP61Win      :    WrSelect ("WP61Win");
   |   Menu.WP62Win      :    WrSelect ("WP62Win");
   |   Menu.Zekt         :    WrSelect ("Zekt");
   |   Menu.Hide         :    WrSelect ("Press this to make this menu disappear");
   |   Menu.SubMenu      :    WrSelect ("Opens a submenu, independant of the pulldownmenu");
   |   Menu.SaveConfig   :    WrSelect ("Toggle this to save preferences");
   |   Menu.SaveConf2    :    WrSelect ("Toggle this to save preferences");
   |   Menu.Swapping     :    WrSelect ("Toggle this to setup swapping type");
   END;
RETURN 0 ;
END Select;

PROCEDURE Help(InCode,H:CARDINAL):CARDINAL;
(* Called when help is pressed on a pulldown menuitem *)

BEGIN
   CASE InCode OF
   | MAX(CARDINAL)  : RETURN 0;
   |   Menu.NewFile      :    WrHelp ("(Menu) NewFile");
   |   Menu.Con_Serv     :    WrHelp ("(Menu) Con_Serv");
   |   Menu.Chemnet      :    WrHelp ("(Menu) Chemnet");
   |   Menu.SpreadSheet  :    WrHelp ("(Menu) SpreadSheet");
   |   Menu.TopSpeed     :    WrHelp ("(Menu) TopSpeed");
   |   Menu.ExeFile      :    WrHelp ("(Menu) ExeFile");
   |   Menu.WWine        :    WrHelp ("(Menu) WWine");
   |   Menu.WordProc     :    WrHelp ("(Menu) WordProc");
   |   Menu.WordPerf     :    WrHelp ("(Menu) WordPerf");
   |   Menu.Borland      :    WrHelp ("(Menu) Borland");
   |   Menu.Archive      :    WrHelp ("(Menu) Archive");
   |   Menu.Communicat   :    WrHelp ("(Menu) Communicat");
   |   Menu.Stack        :    WrHelp ("(Menu) Stack");
   |   Menu.ImageAl      :    WrHelp ("(Menu) ImageAl");
   |   Menu.Programming  :    WrHelp ("(Menu) Programming");
   |   Menu.alch_BMP     :    WrHelp ("alch_BMP");
   |   Menu.alch_Gif     :    WrHelp ("alch_Gif");
   |   Menu.alch_Hand    :    WrHelp ("alch_Hand");
   |   Menu.alch_JPG     :    WrHelp ("alch_JPG");
   |   Menu.ArchARJ      :    WrHelp ("ArchARJ");
   |   Menu.ArchLZH      :    WrHelp ("ArchLZH");
   |   Menu.ArchPAQ      :    WrHelp ("ArchPAQ");
   |   Menu.ArchRAR      :    WrHelp ("ArchRAR");
   |   Menu.ArchUC2      :    WrHelp ("ArchUC2");
   |   Menu.ArchZIP      :    WrHelp ("ArchZIP");
   |   Menu.BC4          :    WrHelp ("BC4");
   |   Menu.BmpTarga     :    WrHelp ("BmpTarga");
   |   Menu.Bordeaux     :    WrHelp ("Bordeaux");
   |   Menu.Bourgogne    :    WrHelp ("Bourgogne");
   |   Menu.BP7          :    WrHelp ("BP7");
   |   Menu.Champagne    :    WrHelp ("Champagne");
   |   Menu.Chem1        :    WrHelp ("Chem1");
   |   Menu.Chem2        :    WrHelp ("Chem2");
   |   Menu.Chem3        :    WrHelp ("Chem3");
   |   Menu.Copy         :    WrHelp ("Copy");
   |   Menu.Cut          :    WrHelp ("Cut");
   |   Menu.Delete       :    WrHelp ("Delete");
   |   Menu.DosShell     :    WrHelp ("DosShell");
   |   Menu.EndProgram   :    WrHelp ("EndProgram");
   |   Menu.Epsilon      :    WrHelp ("Epsilon");
   |   Menu.Excel        :    WrHelp ("Excel");
   |   Menu.Exit         :    WrHelp ("Exit");
   |   Menu.GifJpg       :    WrHelp ("GifJpg");
   |   Menu.GNU          :    WrHelp ("GNU");
   |   Menu.Help_Ind     :    WrHelp ("Help_Ind");
   |   Menu.Help_Instal  :    WrHelp ("Help_Instal");
   |   Menu.Help_Rebuild :    WrHelp ("Help_Rebuild");
   |   Menu.Help_Search  :    WrHelp ("Help_Search");
   |   Menu.Help_Topics  :    WrHelp ("Help_Topics");
   |   Menu.Help_Tutorial:    WrHelp ("Help_Tutorial");
   |   Menu.HIO1         :    WrHelp ("HIO1");
   |   Menu.HIO2         :    WrHelp ("HIO2");
   |   Menu.ImportClip   :    WrHelp ("ImportClip");
   |   Menu.Insert       :    WrHelp ("Insert");
   |   Menu.JpgBmp       :    WrHelp ("JpgBmp");
   |   Menu.Lite         :    WrHelp ("Lite");
   |   Menu.Load         :    WrHelp ("Load");
   |   Menu.LoadBlk      :    WrHelp ("LoadBlk");
   |   Menu.Lotus22      :    WrHelp ("Lotus22");
   |   Menu.Lotus31      :    WrHelp ("Lotus31");
   |   Menu.Make         :    WrHelp ("Make");
   |   Menu.Moezel       :    WrHelp ("Moezel");
   |   Menu.NewBatToExe  :    WrHelp ("NewBatToExe");
   |   Menu.NewCom       :    WrHelp ("NewCom");
   |   Menu.NewDeskTop   :    WrHelp ("NewDeskTop");
   |   Menu.NewExe       :    WrHelp ("NewExe");
   |   Menu.NewObj       :    WrHelp ("NewObj");
   |   Menu.NewPklite    :    WrHelp ("NewPklite");
   |   Menu.NewSource    :    WrHelp ("NewSource");
   |   Menu.NulModem     :    WrHelp ("NulModem");
   |   Menu.Paste        :    WrHelp ("Paste");
   |   Menu.QPro         :    WrHelp ("QPro");
   |   Menu.Quit         :    WrHelp ("Quit");
   |   Menu.RedWine      :    WrHelp ("RedWine");
   |   Menu.Return       :    WrHelp ("Return");
   |   Menu.Save         :    WrHelp ("Save");
   |   Menu.SaveBlk      :    WrHelp ("SaveBlk");
   |   Menu.SaveOnlyMain :    WrHelp ("SaveOnlyMain");
   |   Menu.Snail        :    WrHelp ("Snail");
   |   Menu.Sort         :    WrHelp ("Sort");
   |   Menu.StayResd     :    WrHelp ("StayResd");
   |   Menu.Terra        :    WrHelp ("Terra");
   |   Menu.TeX          :    WrHelp ("TeX");
   |   Menu.Toad         :    WrHelp ("Toad");
   |   Menu.TS117        :    WrHelp ("TS117");
   |   Menu.TS31         :    WrHelp ("TS31");
   |   Menu.Turtle       :    WrHelp ("Turtle");
   |   Menu.VinPays      :    WrHelp ("VinPays");
   |   Menu.Word60       :    WrHelp ("Word60");
   |   Menu.WP51         :    WrHelp ("WP51");
   |   Menu.WP60         :    WrHelp ("WP60");
   |   Menu.WP61Win      :    WrHelp ("WP61Win");
   |   Menu.WP62Win      :    WrHelp ("WP62Win");
   |   Menu.Zekt         :    WrHelp ("Zekt");
   |   Menu.Hide         :    OtherHelp(ADR(HidePullHelp));
   |   Menu.SubMenu      :    OtherHelp(ADR(SubHelp));
   |   Menu.SaveConfig   :    OtherHelp(ADR(SaveHelp));
   |   Menu.SaveConf2    :    OtherHelp(ADR(SaveHelp));
   |   Menu.Swapping     :    OtherHelp(ADR(SwapHelp));
   END;
RETURN 0 ;
END Help;

PROCEDURE Displ();
(* Creates background*)

VAR I : CARDINAL;
    S : ARRAY[0..80] OF CHAR;

BEGIN
 Window.TextColor(Window.LightGray);
 FOR I:= 3 TO 22 DO
  Window.GotoXY(1,I); IO.WrCharRep(CHR(177),80);
  END;
 Window.TextColor(Window.Blue);
 Window.GotoXY(1,2);  IO.WrCharRep("",80);
 Window.GotoXY(1,23); IO.WrCharRep("",80);
 Window.TextColor(Window.Color(4));
 Window.GotoXY(2,24); IO.WrCharRep(" ",77);
 Window.GotoXY((78-Length(StatusLine)) DIV 2+1,24);
 IO.WrStr(StatusLine);
END Displ;

 (* The colorscheme in below definition is horrible, but all colors are
      different, so that all selectable colors can be seen.
      pulldown menu demo. *)

(*                    KeyCol,             (* Color of predefined keys*)
                    Text,               (* Color of normal text (in menu) *)
                    InCol,              (* Background color menu when not lit*)
                    HiCol,              (* textcolor menu when lit*)
                    HiBack,             (* background color menu when lit*)
                    Rand,               (* Color of menu's border*)
                    RandBack,           (* Background color of menu's border.*)
                    TextTop,            (* Color of Top when not lit *)
                    Top,                (* Background of Top when not lit *)
                    HiTop,              (* Textcolor of Top when lit *)
                    HiBTop : Color;     (* Background of Top when lit*)
 *)
CONST PullD= PullDef(ColT(LightMagenta,LightGray,DarkGray,Black,LightGreen,
                   Yellow,LightGray,Blue,DarkGray,LightBlue,LightGray,Style3),
                   TRUE,22,DoPull,Help,Select);

VAR
    H   : PullHandle;
    I   : CARDINAL;

BEGIN
 EnableBreakCheck;                      (* Breaking with Ctrl-break possible*)

 Displ;                                 (* Create the background*)
 H:=PullOpen(PullObject(PullA),PullD);  (* Initialize pulldownmenu*)
 I:=GetPullKey(H,1);                    (* Operate pulldownmenu*)
 PullClose(H);                          (* Close  pulldownmenu*)
END PullDemo.