MODULE QuoSetup;

IMPORT Str,Window,FIO;
FROM Lib     IMPORT Move,Fill;
FROM Window  IMPORT GotoXY,Color,TextColor,CursorOn,CursorOff,FrameStr,WinType,WinDef,TextBackground,DoubleFrame;
FROM ELib    IMPORT GetKey,SToCard,CardToS;
FROM CoreEFIO IMPORT Wr16,Rd16;
FROM IO      IMPORT WrStr,WrCharRep,WrCard,WrLn,WrChar;
FROM Storage IMPORT ALLOCATE;
FROM CoreCrt IMPORT SetCurSize;
FROM WinProc IMPORT InputStr,SetAttrs,

                    Selector,ProcD,ProcI,ProcS,EditRec,EditRecord,
                    SelectEditRec,EditArray,
                    Arr4Card,

                    InitBigStr,PBackGrType,InBigPtr,GetStrPtr,
                    BuildScreenFromPtr,NormalColor;

FROM QuoLocal IMPORT TemplateType,InterArr,IntRec,LocalArr,LocalRec,
                     BackGrndInter,BackGrndLocal,TSLocal,TSINT,Cyfer,GetNumber,
                     ConfName,AlfaBeta,TotalLocalRec,LocalEdit,TSMainRec,MainRec,
                     MainEditBackGr,MainEditProc;


CONST (* ELib.GetKey codes *)
(*   Insert = 05200H;        Delete = 05300H;                CR=13;
   F1  = 3B00H; *)

VAR
       Templ      : POINTER TO TemplateType;


PROCEDURE FdBackGr;

VAR I : CARDINAL;
    S : ARRAY[0..80] OF CHAR;

BEGIN
 Window.TextColor(Window.LightGray);
 FOR I:= 3 TO 22 DO
  Window.GotoXY(1,I); WrCharRep(CHR(177),80);
  END;
 Window.TextColor(Window.Blue);
 Window.GotoXY(1,2);  WrCharRep("",80);
 Window.GotoXY(1,23); WrCharRep("",80);
 Window.TextColor(Window.Color(4));
 Window.GotoXY(2,24); WrCharRep(" ",77);
END FdBackGr;

(* Array Edit procedures *)

PROCEDURE ArrEditBackGr;
BEGIN
 GotoXY(5,1);
 TextColor(Yellow);
 WrStr("Country Tag"); GotoXY(40,1); WrStr("TelNr");
END ArrEditBackGr;

(* Table to convert ALT-x codes back to ordinal type *)
TYPE Card26Type= ARRAY[1..26] OF CARDINAL;
CONST AltKeys=Card26Type(1E00H,3000H,2E00H,2000H,1200H,2100H,2200H,2300H,1700H,
                         2400H,2500H,2600H,3200H,3100H,1800H,1900H,1000H,1300H,
                         1F00H,1400H,1600H,2F00H,1100H,2D00H,1500H,2C00H);

PROCEDURE OtherArrKeys(Key :CARDINAL;VAR CRec,NrRec : CARDINAL);

VAR A,B :CARDINAL;

  CONST   F1  = 3B00H;

BEGIN
 CASE Key OF
  |ORD("A")..ORD("Z") : Move(ADR(Templ^[Key-64]),ADR(InterArr^[CRec]),SIZE(IntRec));
  | F1     :  IF NrRec >1 THEN
              (* ReSort( NrRec );*)
               CRec:=1;
               END;
  END;
 IF Key>255 (* Special Key  *) THEN
  B:=0;
  FOR A:=1 TO 26 DO
   IF Key=AltKeys[A] THEN       (* Key= ALT-A..Z key? *)
    B:=A;                       (* Keep ordinal number*)
    END;
   END;
  IF B>0 THEN                   (* ALT A..Z found  yes -> run action *)
   Move(ADR(InterArr^[CRec]),ADR(Templ^[B]),SIZE(IntRec));
   END;

  END;
END OtherArrKeys;


PROCEDURE ArrEditDisplay(Nr,Y:CARDINAL;Col:BYTE);

BEGIN
 SetAttrs(Col);
 GotoXY(5,Y+2);
 WrCharRep(" ",60);
 GotoXY(5,Y+2);
 WrStr(InterArr^[Nr].Tag);
 GotoXY(40,Y+2);
 WrStr(InterArr^[Nr].SelNumber);
END ArrEditDisplay;

PROCEDURE DelRecPr(VAR Y,Nr:CARDINAL);

BEGIN
 IF Nr=1 THEN
  Nr:=0;
 ELSIF (Nr>1) AND (Y=Nr) THEN
  DEC(Nr);
  DEC(Y);
 ELSIF Nr>1 THEN
  Move(ADR(InterArr^[Nr]),ADR(InterArr^[Y]),SIZE(IntRec));
  DEC(Nr);
  END;
END DelRecPr;

PROCEDURE InsRecPr(VAR Y,Nr:CARDINAL);

BEGIN
 INC(Nr);
 Fill(ADR(InterArr^[Nr]),SIZE(IntRec),0);
END InsRecPr;

(* Edit Record procedures *)

PROCEDURE EditRBackGr;

BEGIN
 BuildScreenFromPtr(TSINT);
END EditRBackGr;

PROCEDURE EditF(Field,Rec :CARDINAL);

VAR
    Fl : BOOLEAN;
    X,Y,
    Len1,Len2 : CARDINAL;
    L : InBigPtr;

BEGIN
 L:=GetStrPtr(TSINT,Field-1);
 X:=ORD(L^[0]); Y:=ORD(L^[1]); Len1:=ORD(L^[2]); Len2:=Str.Length(L^)-3;
 GotoXY(X+Len2,Y);
 CASE Field OF
  |1  : Fl:=InputStr(InterArr^[Rec].Tag,X+Len2,Y,Len1,TRUE,AlfaBeta);
  |2  : Fl:=InputStr(InterArr^[Rec].SelNumber,X+Len2,Y,Len1,TRUE,Cyfer);
  |3..11 :  GetNumber(X,Y,Len1,Len2,InterArr^[Rec].Times[Field-3]);
  |12..20 : GetNumber(X,Y,Len1,Len2,InterArr^[Rec].Costs[Field-12]);
  |21..29 : GetNumber(X,Y,Len1,Len2,InterArr^[Rec].CostsWeek[Field-21]);
  |30     :

 END;
END EditF;

PROCEDURE DisplF(Y2: CARDINAL;NrRec:CARDINAL;Col:BYTE);

VAR Ch,
    Fl : BOOLEAN;
    A,X,Y,
    Len1,Len2 : CARDINAL;
    L : InBigPtr;

BEGIN
 L:=GetStrPtr(TSINT,Y2-1);
 X:=ORD(L^[0]); Y:=ORD(L^[1]); Len1:=ORD(L^[2]); Len2:=Str.Length(L^)-3;
 GotoXY(X+Len2,Y);
 SetAttrs(Col);
 WrCharRep(" ",Len1);
 GotoXY(X+Len2,Y);
 CASE Y2 OF
  |1  : WrStr(InterArr^[NrRec].Tag);
  |2  : WrStr(InterArr^[NrRec].SelNumber);
  |3..11 :  WrCard(InterArr^[NrRec].Times[Y2-3],-INTEGER(Len1));
  |12..20 : WrCard(InterArr^[NrRec].Costs[Y2-12],-INTEGER(Len1));
  |21..29 : WrCard(InterArr^[NrRec].CostsWeek[Y2-21],-INTEGER(Len1));
  | 30    : WrCard(InterArr^[NrRec].Special,-INTEGER(Len1));
   END;
END DisplF;

(* MainProgram*)

CONST EditArr=SelectEditRec(5,5,60,20,TRUE,DoubleFrame,LightCyan,Black,Black,White,
               ArrEditBackGr,ArrEditDisplay,DelRecPr,InsRecPr,OtherArrKeys,30,12,HIGH(InterArr^));

      EditR=EditRec(EditF,EditRBackGr,DisplF,4,5,70,20,TRUE,DoubleFrame,LightCyan,Black,Black,Yellow);

VAR
    TotalIntRec   : CARDINAL;
    Fl            : BOOLEAN;
    OO            : POINTER TO SelectEditRec;
    EE            : POINTER TO EditRec;

PROCEDURE SaveArr;

VAR F: FIO.File;
    A : CARDINAL;

BEGIN
 F:=FIO.Create(ConfName);
 Wr16(F,TotalIntRec);
 Wr16(F,TotalLocalRec);
 Wr16(F,SIZE(MainRec));
 FIO.WrBin(F,MainRec,SIZE(MainRec));

(* This code is modified and used to convert the quo.cfg to a new format when
    new fields are added. *)
(* FOR A:= 1 TO TotalIntRec DO
  FIO.WrBin(F,InterArr^[A],SIZE(IntRec));
  END; *)

 FIO.WrBin(F,InterArr^[1],(SIZE(IntRec))*TotalIntRec);
 FIO.WrBin(F,LocalArr^[1],(SIZE(LocalRec))*TotalLocalRec);

 FIO.Close(F);
END SaveArr;

PROCEDURE LoadArr;

VAR F: FIO.File;
    Dummy : CARDINAL;

BEGIN
 F:=FIO.Open(ConfName);
 TotalIntRec:=Rd16(F);
 TotalLocalRec:=Rd16(F);
 Dummy:=Rd16(F);
 Dummy:=FIO.RdBin(F,MainRec,SIZE(MainRec));

 Dummy:=FIO.RdBin(F,InterArr^[1],SIZE(IntRec)*TotalIntRec);
 Dummy:=FIO.RdBin(F,LocalArr^[1],(SIZE(LocalRec))*TotalLocalRec);
 FIO.Close(F);
END LoadArr;

PROCEDURE MenuLine(A,B:CARDINAL;Col:BYTE);

BEGIN
 SetAttrs(Col);
 GotoXY(4,B+3);
 CASE A OF
 | 1 : WrStr(" General Settings ");
 | 2 : WrStr(" Costs information within your country");
 | 3 : WrStr(" Costs information abroard and for special numbers ");
 END;
END MenuLine;

PROCEDURE SelectMenu;

CONST WD=WinDef(10,4,70,11,LightGray,Black,FALSE,TRUE,FALSE,TRUE,
                Window.DoubleFrame,LightCyan,Black);

VAR CRec,First,
    Key       : CARDINAL;
    Win       : Window.WinType;

BEGIN
 CursorOff;
 Win:=Window.Open(WD);
 Window.Use(Win);
 GotoXY(20,1); TextColor (White);WrStr(" Main menu ");
 TextColor(LightGray);
 First:=1;
 CRec:=First;
   LOOP
      NormalColor  := ORD(LightGray)+ORD(Black)*16;
      Key := Selector(MenuLine, 3, 3, First, CRec);
      CASE Key OF
       | 13      :  
                    CASE CRec OF
                     | 1 : NormalColor  := ORD(White)+ORD(Black)*16;
                           MainEditProc;
                     | 2 : LocalEdit;
                     | 3 : EditArray(OO^,EE^,TotalIntRec);
                     END;
                  Window.Use(Win);
       | 1BH   : EXIT;
        END;
      END;
 Window.Close(Win);
 CursorOn;
END SelectMenu;

CONST        ESC = 1BH;

VAR A : CARDINAL;

BEGIN
  NEW (OO); NEW(EE); (* records can be editted, copy CONST contents*)
  NEW(InterArr); NEW(Templ); NEW(LocalArr);
  FdBackGr;
  IF FIO.Exists(ConfName) THEN
   LoadArr;
  ELSE
   Fill(ADR(InterArr^[0]),SIZE(InterArr),0);
   InterArr^[1].Tag:="Germany";
   InterArr^[1].SelNumber:="31";
   InterArr^[1].Times[0]:=600;    InterArr^[1].Times[1]:=1200;
   InterArr^[1].Times[2]:=1800;   InterArr^[1].Times[3]:=2200;
   InterArr^[1].Times[4]:=2300;
   TotalIntRec:=1;
   END;
  TSINT:=  InitBigStr(ADR(BackGrndInter));
  TSLocal:=InitBigStr(ADR(BackGrndLocal));
  TSMainRec:=InitBigStr(ADR(MainEditBackGr));
  OO^:=EditArr; EE^:=EditR;
  SelectMenu;
  SaveArr;
END QuoSetup.