MODULE SinTab;
(*
Demo(more a gag) of module CorePal,
                    XtdLib package, (C) by Marco van de Voort 1996

Demonstration of the graphics jokes in CorePal, which are meant as a demo of
the capabilities of the assembler and the power of the processor pragmas,
since the processor dependancy is quite important here (pusha/popa/insb/outsb).
*)

FROM CorePal IMPORT RedBar,ColorBars,BarEffect,Copper,SetOne;
FROM ELib    IMPORT EmptyKBD,GetKey;
FROM MATHLIB IMPORT Sin;
FROM Storage IMPORT ALLOCATE,DEALLOCATE;
FROM Lib     IMPORT Fill;

IMPORT IO,Crt;

TYPE  RawPal    =       ARRAY[0..767] OF BYTE;
      RawPtr    =       POINTER TO RawPal;

PROCEDURE FullCopper;

VAR Direction : BOOLEAN;

CONST Size=24;

VAR
    Pal : RawPtr;

PROCEDURE IncBars;
VAR I:CARDINAL;
BEGIN
  IF Direction THEN
   IF Pal^[0]<BYTE(63) THEN INC(Pal^[0]); END;
  ELSE
   IF Pal^[0]>BYTE(0) THEN DEC(Pal^[0]); END;
   END;
  FOR I:=3*Size-2 TO 0 BY -1  DO
   Pal^[I+1]:=Pal^[I];
   END;
END IncBars;

PROCEDURE DoOneCopper(Col:CARDINAL);

VAR U : CARDINAL;

BEGIN
 IF Direction THEN
  Fill(ADR(Pal^),768,0);
 ELSE
  Fill(ADR(Pal^),768,63);
  END;
 FOR U:=0 TO 6*Size DO
  Copper(Size,ADR(Pal^),16,Col);
  IncBars;
  END;
END DoOneCopper;

VAR   A    : CARDINAL;

BEGIN
 Crt.ClrScr;
 Crt.TextColor(Crt.Blue);
 Crt.GotoXY(0,0);
 FOR A:=0 TO 23 DO
  IO.WrStr("No keys necessary, fully automatic :-)."); IO.WrLn;
  END;
 NEW(Pal);
 Direction:=TRUE;
 DoOneCopper(0);
 Direction:=FALSE;
 DoOneCopper(0);
 Direction:=TRUE;
 DoOneCopper(1);
 Direction:=FALSE;
 DoOneCopper(1);
 SetOne(1,0,0,42);
 DISPOSE(Pal);
END FullCopper;

TYPE SinType=ARRAY[0..128] OF CARDINAL;

CONST Co=(2.0*3.1415)/128.0;

VAR A,C : CARDINAL;
    SinTable : SinType;

BEGIN
 (* Calculate Sinus-table *)
  FOR C:=0 TO 128 DO
    SinTable[C]:=1+TRUNC( (Sin(LONGREAL(C)*Co)+1.0)*135.0);
    END;
  REPEAT
   RedBar (SinTable,C);   (* Some graphic joke I found *)
   INC(C);
  UNTIL IO.KeyPressed();
  IO.WrStr("Wait 6 seconds please, irregularities can occur when");
  IO.WrLn;
  IO.WrStr("an event (e.g. staged writes of a cache) occurs");
  ColorBars(6,100,300);          (* Another graphics joke *)
  EmptyKBD;
  Crt.ClrScr;
  IO.WrStr(" Press a key. ");
  Crt.ClrScr;
  EmptyKBD;
  A:=GetKey();
  BarEffect;                     (* And another, this one is a more
                                    sophisticated version of RedBar, a kind of
                                    RedBar with more colors and more bars.
                                    RedBar is easier to understand however*)
  EmptyKBD;
  FullCopper;                    (* And another, again a copperbar, but with a
                                    kind of fade in. *)

END SinTab.
