MODULE SplitSwg;
(* Just an util, but usefull for people who use SWAG
             XtdLib package, (C) by Marco van de Voort 1996

XtdLib dependance limited to LGrow, which you could simply delete.

Split a exported(to ascii in SWAGReader) file in the separate msgs,
Trigger for a new file is ascii 02H

Usage : SplitSwg SwgExportFile Basename

Where SwgExportFile is the file exported by the SWAG reader, and
BaseName the name of the files created.

Assume export.txt contains 100 msgs, and the commandline is
"SplitSwg export.txt swg" then SplitSwg creates swg001.mod thru swg100.mod.

SWAG (SOURCE WARE ARCHIVAL GROUP) is a collection TurboPascal routines. I often
get my ideas there. Downloadable from any Simtel server.

If you gonna translate TP sources, take a look at PAS2MOD.

*)

IMPORT FIO,IO;
FROM Lib IMPORT ParamStr,ParamCount;
FROM IO  IMPORT WrStr,WrLn;
FROM Str IMPORT Delete,Concat,CardToStr,Append;
FROM ELib IMPORT LGrow;

CONST Usage=("Usage : SplitSwg SwgExportFile Basename") + CHR(0DH);

VAR S,S2,S3     : ARRAY[0..50] OF CHAR;
    FIn,FOut    : FIO.File;
    Count       : CARDINAL;
    Ok,Eof      : BOOLEAN;
    B1,B2       : ARRAY[0..4095] OF BYTE;
    C           : CHAR;

BEGIN
 IF ParamCount()<2 THEN
  WrStr(Usage);
  HALT;
  END;
 ParamStr(S,1);
 IF NOT FIO.Exists(S) THEN
  WrStr(Usage);
  HALT;
  END;
 Count:=1;
 FIn:=FIO.Open(S);
 FIO.AssignBuffer(FIn,B1);
 ParamStr(S,2);
 Delete(S,5,40);

 Eof:=FALSE;
 LOOP
  CardToStr(LONGCARD(Count),S2,10,Ok);
(*  LGrow(S2,"0",3); *)
  Concat(S3,S,S2);
  Append(S3,".MOD");
  FOut:=FIO.Create(S3);
  FIO.AssignBuffer(FOut,B2);
  LOOP
   C:=FIO.RdChar(FIn);
   IF FIO.EOF THEN
    Eof:=TRUE;
    EXIT
    END;
   IF (C=CHR(2)) OR (C=CHR(01AH)) THEN
     C:=CHR(13);
    EXIT
    END;
   FIO.WrChar(FOut,C);
   END;
  FIO.Close(FOut);
  IF Eof THEN
   EXIT
   END;
  INC(Count);
  IO.WrCharRep(CHR(8),5);
  IO.WrCard(Count,5);
  END;
 FIO.Close(FIn);
END SplitSwg.