MODULE Waves;
(* Waves, a graphics joke inspired by a Windows screensaver,
   XtdLib package,                      (C) by Marco van de Voort 1997
   but XtdLib independant.

[Flickering]
Why isn't this fast enough ? Is Graph.Line simply too slow? Can't imagine it
 on my computer (Cx686-p166+), what is going wrong? The algoritm works though.
 Most important parameters are constants, so play with them!   *)

IMPORT IO;
FROM Graph IMPORT Line,SetVideoMode,TextMode,ClearScreen,_GCLEARSCREEN;
FROM Lib   IMPORT Delay,RANDOM,RANDOMIZE;

CONST MaxPnt = 6;       (* Maximal points in a line of points, the points
                           have the same absolute speed, and a kind of
                           phase-difference*)
      MaxLine= 4;        (* Maximal lines of points (corners) of a series
                             of polygons *)
      MaxPoly= 3;        (* number of (series of) polygons. *)
      MaxX   = 639;      (* Highest possible X Coordinate (0..MaxX) *)
      MaxY   = 479;      (* Highest possible Y Coordinate (0..MaxY) *)
      DiffX  = 3;        (* Interpoint distance in a line in X coordinates *)
      DiffY  = 3;        (* Interpoint distance in a line in Y coordinates *)

TYPE Point   = RECORD   (* Seems logical *)
                X,Y,                     (* point has coordinates *)
                dX,dY : INTEGER;         (* and a speed *)
                END;

     LineOfPoints= ARRAY[1..MaxPnt] OF Point;  (* a line of points,
                                       different because of a phase shift. *)

     Polygon  = RECORD  (* a series of polygons only different because of
                            a kind of phase shift, all have the same color. *)
                 Pnts : ARRAY[1..MaxLine] OF LineOfPoints;
                 Color: CARDINAL;
                 END;

     PolyArr  = ARRAY[1..MaxPoly] OF Polygon;

PROCEDURE SetupPoly(VAR Poly : Polygon);
(* Setup one Polygon group, take random starting coordinates and speeds*)

VAR Pnt,Lin,
    dX,dY,
    NewX,NewY,
    NewdX,NewdY : INTEGER;

BEGIN
 FOR Lin:=1 TO MaxLine DO
  NewdX:=INTEGER(RANDOM(3))+2;  NewdY:=INTEGER(RANDOM(3))+2;
  NewX :=RANDOM(MaxX);          NewY :=RANDOM(MaxY);

  IF RANDOM(2)=1 THEN           NewdX:=-NewdX;     END;
  IF RANDOM(2)=1 THEN           NewdY:=-NewdY;     END;

  FOR Pnt:=1 TO MaxPnt DO
   Poly.Pnts[Lin][Pnt].dX:=NewdX;         Poly.Pnts[Lin][Pnt].dY:=NewdY;
   Poly.Pnts[Lin][Pnt].X:=NewX+Pnt*DiffX; Poly.Pnts[Lin][Pnt].Y:=NewY+Pnt*DiffY;
   END;
  END;
END SetupPoly;

PROCEDURE DoPoly(Poly:Polygon);


VAR A,Pts : CARDINAL;
    B     : CARDINAL;

BEGIN
 FOR Pts:=1 TO MaxPnt DO
  FOR A:=1 TO MaxLine-1 DO
   Line(Poly.Pnts[A][Pts].X,Poly.Pnts[A][Pts].Y,Poly.Pnts[A+1][Pts].X,Poly.Pnts[A+1][Pts].Y,CARDINAL(Poly.Color));
   END;
  Line(Poly.Pnts[MaxLine][Pts].X,Poly.Pnts[MaxLine][Pts].Y,Poly.Pnts[1][Pts].X,Poly.Pnts[1][Pts].Y,CARDINAL(Poly.Color));
  END;
END DoPoly;

PROCEDURE UpgradePoly(VAR Poly:Polygon);

VAR Lin,Pnt : CARDINAL;

BEGIN
 FOR Lin:=1 TO MaxLine DO
  FOR Pnt:=1 TO MaxPnt DO
   WITH Poly.Pnts[Lin][Pnt] DO
    INC(X,dX);
    INC(Y,dY);
    IF X>MaxX THEN
     X:=2*MaxX-X;
     dX:=-dX;
     END;
    IF Y>MaxY THEN
     Y:=2*MaxY-Y;
     dY:=-dY;
     END;
    IF X<0 THEN
     X:=-X;
     dX:=-dX;
     END;
    IF Y<0 THEN
     Y:=-Y;
     dY:=-dY;
     END;
   END;
  END;
 END;
END UpgradePoly;

VAR Poly : PolyArr;
    Init : CARDINAL;
    PolyNr : CARDINAL;

BEGIN
 RANDOMIZE;
 FOR PolyNr:=1 TO MaxPoly DO
  SetupPoly(Poly[PolyNr]);
  Poly[PolyNr].Color:=RANDOM(15)+1;
  END;
 Init:=CARDINAL(SetVideoMode(18));
 LOOP
  FOR PolyNr:=1 TO MaxPoly DO
   DoPoly(Poly[PolyNr]);
   END;
  Delay(50);

  FOR PolyNr:=1 TO MaxPoly DO           (* Calc new points *)
   UpgradePoly(Poly[PolyNr]);
   END;

(*OR PolyNr:=1 TO MaxPoly DO   DoPoly(PolySwap[PolyNr],FALSE);   END; *)
ClearScreen(_GCLEARSCREEN); (* Faster than drawing xxx lines I hope*)
  IF IO.KeyPressed() THEN
   Init:=CARDINAL(IO.RdKey());
   EXIT;
   END;
  END;
 TextMode;
END Waves.